%% File: template.bib
%%
%% Author: Chuck Gartland
%%
%% A small BibTeX database file for use/testing with the template files
%% DISStemplate.tex and THESIStemplate.tex, which are designed to be used
%% with the LaTeX class files `ksudiss.cls' and `ksuthesis.cls'
%% [2019/08/27 v4.0]
%%
%% History:
%%
%%   2019/08/27: created by Chuck Gartland to accompany the newly created
%%               files DISStemplate.tex and THESIStemplate.tex
%%
%% Bugs: please communicate any bugs or suggestions to
%%       Chuck Gartland (gartland@math.kent.edu)

@MISC{ebpf,
	key = {{ebpf}},
	title = {{eBPF (extened Binary Packet Filter)}},
	note = {
	\url{http://prototype-kernel.readthedocs.io/en/latest/bpf/}
	},
	language = {english},
}

@MISC{intelhls,
	key = {{Intel HLS Compiler}},
	title = {{Intel HLS Compiler}},
	note = {
	\url{https://www.intel.co.uk/content/www/uk/en/software/programmable/quartus-prime/hls-compiler.html}
	},
	language = {english},
}


@MISC{facebookwedge,
	key = {{Facebook Wedge switch}},
	title = {{Facebook Wedge switch}},
	note = {
	\url{https://engineering.fb.com/2016/03/09/data-center-engineering/opening-designs-for-6-pack-and-wedge-100/}
	},
	language = {english},
}

@MISC{intelopencl,
	key = {{Intel OpenCL SDK}},
	title = {{Intel OpenCL SDK}},
	note = {
	\url{https://software.intel.com/content/www/us/en/develop/tools/opencl-sdk.html}
	},
	language = {english},
}

@MISC{sdaccel,
	key = {{Xilinx SDAccel}},
	title = {{Xilinx SDAccel}},
	note = {
	\url{https://www.xilinx.com/products/design-tools/software-zone/sdaccel.html}
	},
	language = {english},
}


@MISC{facebookwedge,
	key = {{facebookwedge}},
	title = {{Facebook Wedge Switch}},
	note = {
	\url{https://people.ucsc.edu/~warner/Bufs/wedge-ocp.pdf}
	},
	language = {english},
}  

@MISC{tofino,
	key = {{Tofino}},
	title = {{Barefoot Tofino}},
	note = {
	\url{https://barefootnetworks.com/products/brief-tofino/}
	},
	language = {english},
}

@MISC{CiscoNCS5500,
	key = {{Cisco NCS 5500 Modular Platform Architecture}},
	title = {{Cisco NCS 5500 Modular Platform Architecture}},
	note = {
	\url{https://www.cisco.com/c/dam/en/us/products/collateral/routers/network-convergence-system-5500-series/ncs5500-modular-platform-architecture-white-paper.pdf}
	},
	language = {english},
}

@MISC{cisconpower,
	key = {{Cisco nPower network processor}},
	title = {{Cisco nPower network processor}},
	note = {
	\url{https://www.eetimes.com/mega-asic-drives-cisco-router}
	},
	language = {english},
}

@MISC{NokiaFP,
	key = {{Nokia FP network processor}},
	title = {{Nokia FP network processor}},
	note = {
	\url{https://www.nokia.com/networks/technologies/fp-network-processor-technology/}
	},
	language = {english},
}

@MISC{JuniperTrio,
	key = {{Juniper Trio: INSIDE THE MX 5G}},
	title = {{Juniper Trio: INSIDE THE MX 5G}},
	note = {
	\url{https://www.juniper.net/documentation/en_US/day-one-books/DO_MX5G.pdf}
	},
	language = {english},
}

@book{hanks2012juniper,
	title={Juniper MX series},
	author={Hanks, Douglas and Reynolds, Harry},
	year={2012},
	publisher={" O'Reilly Media, Inc."}
}

@MISC{attcorerouter,
	key = {{AT\&T is First in Industry to Deploy Open Dis-Aggregated Core Router}},
	title = {{AT\&T is First in Industry to Deploy Open Dis-Aggregated Core Router}},
	note = {
	\url{https://about.att.com/story/2020/open_disaggregated_core_router.html}
	},
	language = {english},
}

@MISC{SiliconOne,
	key = {{Cisco Silicon One}},
	title = {{Cisco Silicon One}},
	note = {
	\url{https://www.cisco.com/c/en/us/solutions/collateral/silicon-one/datasheet-c78-744312.html}
	},
	language = {english},
}

@MISC{Yosys,
	author = {Clifford Wolf},
	title = {Yosys Open SYnthesis Suite},
	howpublished = "\url{http://www.clifford.at/yosys/}"
}

@article{wolfyosys,
	title={{Yosys manual}},
	author={Wolf, Clifford}
}

@inproceedings{singh2008kiwi,
	title={Kiwi: Synthesis of FPGA circuits from parallel programs},
	author={Singh, Satnam and Greaves, David J},
	booktitle={IEEE FCCM},
	pages={3--12},
	year={2008}
}

@inproceedings{pelcat2016design,
	title={Design productivity of a high level synthesis compiler versus HDL},
	author={Pelcat, Maxime and Bourrasset, C{\'e}dric and Maggiani, Luca and Berry, Fran{\c{c}}ois},
	booktitle={IEEE SAMOS},
	pages={140--147},
	year={2016}
}

@MISC{tsc,
	key = {{CPU performance couter (TSC register)}},
	title = {{CPU performance couter (TSC register)}},
	note = {
	\url{https://en.wikipedia.org/wiki/Time_Stamp_Counter}
	},
	language = {english},
}

@MISC{aladdinpowermodel,
	key = {{Timing, Power and Area of OpenPDK 45nm mixed cell library}},
	title = {{Timing, Power and Area of OpenPDK 45nm mixed cell library}},
	note = {
	\url{https://github.com/ysshao/ALADDIN/blob/master/common/power_func.h}
	},
	language = {english},
}

@MISC{cumulus,
	key = {{Cumulus Network}},
	title = {{Cumulus Network}},
	note = {
	\url{https://cumulusnetworks.com/}
	},
	language = {english},
}

@book{giladi2008network,
	title={Network processors: architecture, programming, and implementation},
	author={Giladi, Ran},
	year={2008},
	publisher={Morgan Kaufmann}
}

@inproceedings{ji2001fast,
	title={Fast IP routing lookup with configurable processor and compressed routing table},
	author={Ji, H Michael and Srinivasan, Ranga},
	booktitle={IEEE GLOBECOM},
	volume={4},
	pages={2373--2377},
	year={2001}
}

@MISC{tensilicatioIPForwarding,
	key = {{Tensilica Xtensa Processor Extensions for Fast IP Packet Forwarding}},
	title = {{Tensilica Xtensa Processor Extensions for Fast IP Packet Forwarding}},
	note = {
	\url{https://archive.eetasia.com/www.eetasia.com/STATIC/PDF/200809/EEOL_2008SEP04_EDA_AN_03.pdf?SOURCES=DOWNLOAD}
	},
	language = {english},
}

@MISC{tensilicaxtensa,
	key = {{Tensilica Xtensa}},
	title = {{Tensilica Xtensa}},
	note = {
	\url{https://www.cadence.com/en_US/home/training/all-courses/86037.html}
	},
	language = {english},
}

@MISC{synopsysasipdesigner,
	key = {{Synopsys ASIP Designer}},
	title = {{Synopsys ASIP Designer}},
	note = {
	\url{https://www.synopsys.com/dw/ipdir.php?ds=asip-designer}
	},
	language = {english},
}

@MISC{codasipstudio,
	key = {{Codasip Studio}},
	title = {{Codasip Studio}},
	note = {
	\url{https://codasip.com/products/codasip-studio/}
	},
	language = {english},
}

@article{wheeler2013new,
	title={A new era of network processing},
	author={Wheeler, Bob},
	journal={LinleyGroup Bob Wheeler's White paper},
	year={2013}
}

@MISC{FreePDK,
	key = {{FreePDK}},
	title = {{FreePDK}},
	note = {
	\url{https://www.eda.ncsu.edu/wiki/FreePDK}
	},
	language = {english},
}

@MISC{xplaint,
	key = {{xplaint}},
	title = {{Cavium XPliant}},
	note = {
	\url{http://www.cavium.com/pdfFiles/CNX880XX_PB_Rev1.pdf}
	},
	language = {english},
}


@MISC{Jerichodatasheet,
	key = {{Brodcom Jericho}},
	title = {{Brodcom Jericho}},
	note = {
	\url{https://docs.broadcom.com/doc/88690-PB100}
	},
	language = {english},
}

@MISC{tridentdatasheet,
	key = {{Brodcom Trident}},
	title = {{Brodcom Trident}},
	note = {
	\url{https://www.broadcom.com/products/ethernet-connectivity/switching/strataxgs/bcm56880-series}
	},
	language = {english},
}

@MISC{Tomahawk3,
	key = {{Brodcom Tomahawk 3}},
	title = {{Brodcom Tomahawk 3}},
	note = {
	\url{https://www.broadcom.com/products/ethernet-connectivity/switching/strataxgs/bcm56980-series}
	},
	language = {english},
}

@MISC{Tomahawk4,
	key = {{Brodcom Tomahawk 4}},
	title = {{Brodcom Tomahawk 4}},
	note = {
	\url{https://www.broadcom.com/products/ethernet-connectivity/switching/strataxgs/bcm56990-series}
	},
	language = {english},
}

@MISC{Jerichotalk,
	key = {{Tech Field Day talk: Broadcom Jericho2 - Driving the Merchant Silicon Revolution in Service Provider Networks}},
	title = {{Tech Field Day talk: Broadcom Jericho2 - Driving the Merchant Silicon Revolution in Service Provider Networks}},
	note = {
	\url{https://www.youtube.com/watch?v=n9bUEb1v0pU}
	},
	language = {english},
}


@MISC{Tomahawktalk,
	key = {{Tech Field Day talk: Broadcom Tomahawk4}},
	title = {{Tech Field Day talk: Broadcom Tomahawk4}},
	note = {
	\url{https://www.youtube.com/watch?v=B-COGMbaUg4}
	},
	language = {english},
}

@MISC{SiliconOnetalk,
	key = {{Tech Field Day talk: Cisco Silicon One}},
	title = {{Tech Field Day talk: Cisco Silicon One}},
	note = {
	\url{https://www.youtube.com/watch?v=KIGct1QOtdI}
	},
	language = {english},
}

@MISC{BarefootTofinotalk,
	key = {{Tech Field Day talk: Barefoot Tofino}},
	title = {{Tech Field Day talk: Barefoot Tofino}},
	note = {
	\url{https://www.youtube.com/watch?v=BqOp6w_7cGI}
	},
	language = {english},
}

@MISC{Brodcomswitchtalk,
	key = {{Tech Field Day talk: Introduction to Broadcom's Switch Portfolio}},
	title = {{Tech Field Day talk: Introduction to Broadcom's Switch Portfolio}},
	note = {
	\url{https://www.youtube.com/watch?v=t_fwyKs1wJ0}
	},
	language = {english},
}

@MISC{merchecntasiccisco,
	key = {{Cisco Nexus 3000 Switch Architecture}},
	title = {{Cisco Nexus 3000 Switch Architecture}},
	note = {
	\url{https://www.ciscolive.com/c/dam/r/ciscolive/us/docs/2018/pdf/BRKDCN-3734.pdf}
	},
	language = {english},
}

@article{wheeler2019tomahawk,
	title={Tomahawk 4 switch first to 25.6 Tbps},
	author={Wheeler, B},
	journal={Microprocessor Report-Newsletter},
	year={2019}
}

@MISC{Arista7500R3,
	key = {{Arista 7500R3 Platform Architecture}},
	title = {{Arista 7500R3 Platform Architecture}},
	note = {
	\url{https://www.arista.com/assets/data/pdf/Whitepapers/Arista7500R3SwitchArchitectureWP.pdf}
	},
	language = {english},
}

@MISC{Arista7050X3,
	key = {{Arista 7050X3 Series Switch Architecture}},
	title = {{Arista 7050X3 Series Switch Architecture}},
	note = {
	\url{https://www.arista.com/assets/data/pdf/Whitepapers/7050X3_Architecture_WP.pdf}
	},
	language = {english},
}

@MISC{ethernetasic,
	key = {{A summary of High Speed Ethernet ASICs}},
	title = {{A summary of High Speed Ethernet ASICs}},
	note = {
	\url{https://medium.com/the-elegant-network/a-summary-of-high-speed-ethernet-asics-260637c50583}
	},
	language = {english},
}

@MISC{NephosTaurassheet,
	key = {{Nephos Tauras}},
	title = {{Nephos Tauras}},
	note = {
	\url{http://www.nephosinc.com/nps/products/}
	},
	language = {english},
}

@MISC{MellanoxSpectrumdatasheet,
	key = {{Mellanox Spectrum}},
	title = {{Mellanox Spectrum}},
	note = {
	\url{https://www.mellanox.com/files/doc-2020/pb-spectrum-3.pdf}
	},
	language = {english},
}


@MISC{InnoviumTERALYNXdatasheet,
	key = {{Innovium TERALYNX}},
	title = {{Innovium TERALYNX}},
	note = {
	\url{https://www.innovium.com/wp-content/uploads/Innovium_TL8_Product_Brief_v1.0.pdf}
	},
	language = {english},
}

@MISC{XsightLabX1datasheet,
	key = {{Xsight Lab X1}},
	title = {{Xsight Lab X1}},
	note = {
	\url{https://xsightlabs.com/x1-ethernet-switches/}
	},
	language = {english},
}


@MISC{centecTsingMa,
	key = {{Centec TsingMa}},
	title = {{Centec TsingMa}},
	note = {
	\url{https://www.centecnetworks.com/silicon/4}
	},
	language = {english},
}

@MISC{ripe,
	key = {{RIPE Network Coordination Centre}},
	title = {{RIPE Network Coordination Centre}},
	note = {
	\url{https://www.ripe.net/}
	},
	language = {english},
}

@MISC{routeviews,
	key = {{Route Views Project}},
	title = {{Route Views Project}},
	note = {
	\url{http://www.routeviews.org/routeviews/}
	},
	language = {english},
}

@MISC{wide-mawi,
	key = {{WIDE Project MAWI Working Group Traffic Archive}},
	title = {{WIDE Project MAWI Working Group Traffic Archive}},
	note = {
	\url{http://mawi.wide.ad.jp/mawi/}
	},
	language = {english},
}

@MISC{caida,
	key = {{CAIDA Anonymized Internet Trace}},
	title = {{CAIDA Anonymized Internet Trace}},
	note = {
	\url{https://www.caida.org}
	},
	language = {english},
}

@MISC{bgpreport,
	key = {{BGP Report}},
	title = {{BGP Report}},
	note = {
	\url{http://bgp.potaroo.net/}
	},
	language = {english},
}

@MISC{x86instructions,
	key = {{x86 Instruction Set Reference}},
	title = {{x86 Instruction Set Reference}},
	note = {
	\url{https://c9x.me/x86/}
	},
	language = {english},
}

@inproceedings{vanjacobson,
	author = "Van Jacobson and Michael J. Karels",
	title = "Congestion Avoidance and Control",
	booktitle = "SIGCOMM 1988",
	address = "Stanford, CA",
	month = aug,
	year = 1988
}

@inproceedings{yang2014guarantee,
	title={{Guarantee IP lookup performance with FIB explosion}},
	author={Yang, Tong and Xie, Gaogang and Li, YanBiao and Fu, Qiaobin and Liu, Alex X and Li, Qi and Mathy, Laurent},
	booktitle={ACM SIGCOMM 2014},
}

@inproceedings{waldvogel1997scalable,
	title={{Scalable high speed IP routing lookups}},
	author={Waldvogel, Marcel and Varghese, George and Turner, Jon and Plattner, Bernhard},
	booktitle={ACM SIGCOMM},
	pages={25--36},
	year={1997}
}

@inproceedings{broder2001using,
	title={{Using multiple hash functions to improve IP lookups}},
	author={Broder, Andrei and Mitzenmacher, Michael},
	booktitle={IEEE INFOCOM},
	volume={3},
	pages={1454--1463},
	year={2001}
}

@article{kirsch2010power,
	title={The power of one move: Hashing schemes for hardware},
	author={Kirsch, Adam and Mitzenmacher, Michael},
	journal={IEEE/ACM Transactions on Networking},
	volume={18},
	number={6},
	pages={1752--1765},
	year={2010}
}

@article{pong2009suse,
	title={{SUSE: Superior storage-efficiency for routing tables through prefix transformation and aggregation}},
	author={Pong, Fong and Tzeng, Nian-Feng},
	journal={IEEE/ACM Transactions on Networking},
	volume={18},
	number={1},
	pages={81--94},
	year={2009}
} 

@article{pong2011concise,
	title={{Concise lookup tables for IPv4 and IPv6 longest prefix matching in scalable routers}},
	author={Pong, Fong and Tzeng, Nian-Feng},
	journal={IEEE/ACM Transactions on Networking},
	volume={20},
	number={3},
	pages={729--741},
	year={2011}
}

@inproceedings{lee2011equivalence,
	title={Equivalence checking of scheduling with speculative code transformations in high-level synthesis},
	author={Lee, Chi-Hui and Shih, Che-Hua and Huang, Juinn-Dar and Jou, Jing-Yang},
	booktitle={IEEE ASP-DAC},
	pages={497--502},
	year={2011}
}

@inproceedings{asai2015poptrie,
	title={{Poptrie: A compressed trie with population count for fast and scalable software IP routing table lookup}},
	author={Asai, Hirochika and Ohara, Yasuhiro},
	booktitle={ACM SIGCOMM 2015},
} 

@article{nilsson1999ip,
	title={{IP-address lookup using LC-tries}},
	author={Nilsson, Stefan and Karlsson, Gunnar},
	journal={IEEE Journal on selected Areas in Communications (JSAC)},
	volume={17},
	number={6},
	pages={1083--1092},
	year={1999},
}

@inproceedings{asai2020palmtrie,
	title={Palmtrie: a ternary key matching algorithm for IP packet filtering rules},
	author={Asai, Hirochika},
	booktitle={ACM CoNEXT},
	pages={323--335},
	year={2020}
}

@article{schafer2019high,
	title={High-Level Synthesis Design Space Exploration: Past, Present, and Future},
	author={Schafer, Benjamin Carrion and Wang, Zi},
	journal={IEEE Transactions on Computer-Aided Design of Integrated Circuits and Systems (TCAD)},
	volume={39},
	number={10},
	pages={2628--2639},
	year={2019}
}

@article{siracusa2020tensor,
	title={Tensor Optimization for High-Level Synthesis Design Flows},
	author={Siracusa, Marco and Ferrandi, Fabrizio},
	journal={IEEE Transactions on Computer-Aided Design of Integrated Circuits and Systems (TCAD)},
	volume={39},
	number={11},
	pages={4217--4228},
	year={2020}
}

@article{petrisko2020blackparrot,
	title={Blackparrot: An agile open-source risc-v multicore for accelerator socs},
	author={Petrisko, Daniel and Gilani, Farzam and Wyse, Mark and Jung, Dai Cheol and Davidson, Scott and Gao, Paul and Zhao, Chun and Azad, Zahra and Canakci, Sadullah and Veluri, Bandhav and others},
	journal={IEEE Micro},
	volume={40},
	number={4},
	pages={93--102},
	year={2020}
}

@inproceedings{kundu2008validating,
	title={Validating high-level synthesis},
	author={Kundu, Sudipta and Lerner, Sorin and Gupta, Rajesh},
	booktitle={International Conference on Computer Aided Verification},
	pages={459--472},
	year={2008},
	organization={Springer}
}

@article{herklotz2021formal,
	title={Formal Verification of High-Level Synthesis},
	author={Herklotz, Yann and POLLARD, JAMES D and Ramanathan, Nadesh and Wickerson, John},
	journal={ACM OOPSLA},
	year={2021}
}

@inproceedings{yu2009hash,
	title={{A hash-based scalable IP lookup using Bloom and fingerprint filters}},
	author={Yu, Heeyeol and Mahapatra, Rabi and Bhuyan, Laxmi},
	booktitle={IEEE ICNP},
	pages={264--273},
	year={2009}
}

@inproceedings{gallenmuller2015comparison,
	title={{Comparison of frameworks for high-performance packet IO}},
	author={Gallenm{\"u}ller, Sebastian and Emmerich, Paul and Wohlfart, Florian and Raumer, Daniel and Carle, Georg},
	booktitle={ACM/IEEE ANCS},
	year={2015}
}


@inproceedings{ancskeynote,
	title={{The Forwarding Plane: An Old New Frontier of Networking Research}},
	author={Changhoon Kim,},
	booktitle={Keynotes at ACM SOSR and ACM/IEEE ANCS},
	year={2018}
}


@inproceedings{zhou2013scalable,
	title={{Scalable, high performance ethernet forwarding with CuckooSwitch}},
	author={Zhou, Dong and Fan, Bin and Lim, Hyeontaek and Kaminsky, Michael and Andersen, David G},
	booktitle={ACM CoNEXT},
	pages={97--108},
	year={2013}
}


@inproceedings{fu2006performance,
	title={{Performance evaluation and cache behavior of LC-trie for IP-address lookup}},
	author={Fu, Jing and Hagsand, Olof and Karlsson, Gunnar},
	booktitle={IEEE HPSR},
	pages={7--pp},
	year={2006},
}

@article{zec2012dxr,
	title={{DXR: towards a billion routing lookups per second in software}},
	author={Zec, Marko and Rizzo, Luigi and Mikuc, Miljenko},
	journal={ACM SIGCOMM Computer Communication Review},
	volume={42},
	number={5},
	pages={29--36},
	year={2012},
}

@article{tsakyridis202025,
	title={25.6 Tbps capacity and sub-$\mu$sec latency switching for datacenters using> 1000-port optical packet switch architectures},
	author={Tsakyridis, Apostolos and Terzenidis, Nikos and Giamougiannis, George and Moralis-Pegios, Miltiadis and Vyrsokinos, Konstantinos and Pleros, Nikos},
	journal={IEEE Journal of Selected Topics in Quantum Electronics},
	volume={27},
	number={2},
	pages={1--11},
	year={2020}
}

@inproceedings{attig2011400,
	title={400 Gb/s programmable packet parsing on a single FPGA},
	author={Attig, Michael and Brebner, Gordon},
	booktitle={ACM/IEEE ANCS},
	pages={12--23},
	year={2011}
}

@article{liu2021hyperparser,
	title={{HyperParser: A High-Performance Parser Architecture for Next Generation Programmable Switch and SmartNIC}},
	author={Liu, Huan and Qiu, Zhiliang and Pan, Weitao and Li, Jiajun and Huang, Jinjian},
	journal={ACM APNet},
	year={2021}
}

@inproceedings{zilberman2019stardust,
	title={Stardust: Divide and conquer in the data center network},
	author={Zilberman, Noa and Bracha, Gabi and Schzukin, Golan},
	booktitle={USENIX NSDI},
	pages={141--160},
	year={2019}
}

@inproceedings{uzmi2011smalta,
	title={{SMALTA: practical and near-optimal FIB aggregation}},
	author={Uzmi, Zartash Afzal and Nebel, Markus and Tariq, Ahsan and Jawad, Sana and Chen, Ruichuan and Shaikh, Aman and Wang, Jia and Francis, Paul},
	booktitle={ACM CoNEXT},
	pages={1--12},
	year={2011}
}

@inproceedings{liu2013fifa,
	title={FIFA: Fast incremental FIB aggregation},
	author={Liu, Yaoqing and Zhang, Beichuan and Wang, Lan},
	booktitle={IEEE INFOCOM},
	pages={1--9},
	year={2013}
}

@inproceedings{islam2019sail,
	title={{SAIL based FIB lookup in a programmable pipeline based Linux router}},
	author={Islam, MD Iftakharul and Khan, Javed I},
	booktitle={IEEE HPSR},
	pages={1--8},
	year={2019}
}

@inproceedings{liu2019longest,
	title={Longest prefix matching with pruning},
	author={Liu, Lingtong and Hu, Jun and Yan, Yibo and Gao, Siang and Yang, Tong and Li, Xiaoming},
	booktitle={IEEE HPSR},
	pages={1--6}, 
	year={2019}
} 

@inproceedings{retvari2013compressing,
	title={{Compressing IP forwarding tables: towards entropy bounds and beyond}},
	author={R{\'e}tv{\'a}ri, G{\'a}bor and Tapolcai, J{\'a}nos and K{\H{o}}r{\"o}si, Attila and Majd{\'a}n, Andr{\'a}s and Heszberger, Zal{\'a}n},
	booktitle={ACM SIGCOMM Computer Communication Review},
	volume={43},
	number={4},
	pages={111--122},
	year={2013}
} 

@inproceedings{huang2011offset,
	title={{Offset addressing approach to memory-efficient IP address lookup}},
	author={Huang, Kun and Xie, Gaogang and Li, Yanbiao and Liu, Alex X},
	booktitle={IEEE INFOCOM},
	pages={306--310},
	year={2011}
} 

@inproceedings{song2009scalable,
	title={{Scalable IP lookups using shape graphs}},
	author={Song, Haoyu and Kodialam, Murali and Hao, Fang and Lakshman, TV},
	booktitle={IEEE ICNP},
	pages={73--82},
	year={2009}
}

@inproceedings{pongracz2013cheap,
	title={{Cheap silicon: a myth or reality? picking the right data plane hardware for software defined networking}},
	author={Pongr{\'a}cz, Gergely and Moln{\'a}r, L{\'a}szl{\'o} and Kis, Zolt{\'a}n Lajos and Tur{\'a}nyi, Zolt{\'a}n},
	booktitle={ACM SIGCOMM workshop on Hot topics in Software Defined Networking},
	pages={103--108},
	year={2013},
}


@MISC{dpdk,
	key = {{dpdk}},
	title = {{Data Plane Development Kit (DPDK)}},
	note = {
	\url{http://dpdk.org/}
	},
	language = {english},
} 

@MISC{fibbackbone,
	key = {{Routing tables of backbone routers}},
	title = {{Routing tables of backbone routers}},
	note = {
	\url{https://github.com/tamimcse/parse-bgpdump/}
	},
	language = {english},
}

@MISC{icc,
	key = {{Synopsys Fusion Compiler}},
	title = {{Synopsys Fusion Compiler}},
	note = {
	\url{https://www.synopsys.com/implementation-and-signoff/physical-implementation/fusion-compiler.html}
	},
	language = {english},
}

@MISC{innovus,
	key = {{Cadence Innovus}},
	title = {{Cadence Innovus}},
	note = {
	\url{https://www.cadence.com/en_US/home/tools/digital-design-and-signoff/soc-implementation-and-floorplanning/innovus-implementation-system.html}
	},
	language = {english},
}


@MISC{veriloator,
	key = {{Verilator}},
	title = {{Verilator}},
	note = {
	\url{https://www.veripool.org/wiki/verilator}
	},
	language = {english},
}

@MISC{vivado,
	key = {{Xilinx Vivado SDK}},
	title = {{Xilinx Vivado SDK}},
	note = {
	\url{https://www.xilinx.com/products/design-tools/vivado.html}
	},
	language = {english},
}

@MISC{strutus,
	key = {{Cadence Stratus HLS}},
	title = {{Cadence Stratus HLS}},
	note = {
	\url{https://www.cadence.com/en_US/home/tools/digital-design-and-signoff/synthesis/stratus-high-level-synthesis.html}
	},
	language = {english},
}

@incollection{wakabayashi2008all,
	title={{All-in-C: Behavioral Synthesis and Verification with CyberWorkBench}},
	author={Wakabayashi, Kazutoshi and Schafer, Benjamin Carrion},
	booktitle={High-Level Synthesis},
	pages={113--127},
	year={2008},
	publisher={Springer}
}

@MISC{dolphin-memorycompiler,
	key = {{Dolphin Technology's Memory compiler}},
	title = {{Dolphin Technology's Memory compiler}},
	note = {
	\url{http://www.dolphin-ic.com/memory-products.html}
	},
	language = {english},
}

@MISC{sailpatch,
	key = {{SAIL-BM implementation in Linux kernel}},
	title = {{SAIL-BM implementation in Linux kernel (patch)}},
	note = {
	\url{https://github.com/tamimcse/kernel-patches/blob/master/xdp-sail.patch/}
	},
	language = {english},
}

@MISC{saillpatch,
	key = {{SAIL-L implementation in Linux kernel}},
	title = {{SAIL-L implementation in Linux kernel (patch)}},
	note = {
	\url{https://github.com/tamimcse/kernel-patches/blob/master/sail-l.patch/}
	},
	language = {english},
}

@MISC{saildomino,
	key = {{Implementation of SAIL-BM using Domino}},
	title = {{Implementation of SAIL-BM using Domino}},
	note = {
	\url{https://github.com/tamimcse/domino-examples/blob/master/domino-programs/sail-bm.c}
	}
	
	@MISC{sailldomino,
	key = {{Implementation of SAIL-L using Domino}},
	title = {{Implementation of SAIL-L using Domino}},
	note = {
	\url{https://github.com/tamimcse/domino-examples/blob/master/domino-programs/sail-l.c}
	}
	
	@MISC{sailpipiline,
	key = {{SAIL-BM Pipeline}},
	title = {{SAIL-BM Pipeline}},
	note = {
	\url{https://raw.githubusercontent.com/tamimcse/domino-examples/master/pipeline-sail-bm.png},
	}
	
	@MISC{vpp,
	key = {{vpp}},
	title = {{Vector Packet Processing (VPP)}},
	note = {
	\url{https://wiki.fd.io/view/VPP}
	},
	language = {english},
	}
	
	
	@MISC{odp,
	key = {{odp}},
	title = {{OpenDataPlane(ODP)}},
	note = {
	\url{https://www.opendataplane.org/}
	},
	language = {english},
	} 
	
	@MISC{xdp,
	key = {{XDP}},
	title = {{XDP (eXpress Data path)}},
	note = {
	\url{http://prototype-kernel.readthedocs.io/en/latest/networking/XDP/introduction.html}
	},
	language = {english},
	}
	
	@inproceedings{hoiland2018express,
	title={{The eXpress Data Path: Fast Programmable Packet Processing in the Operating System Kernel}},
	author={H{\o}iland-J{\o}rgensen, Toke and Brouer, Jesper Dangaard and Borkmann, Daniel and Fastabend, John and Herbert, Tom and Ahern, David and Miller, David},
	booktitle={ACM CoNEXT},
	year={2018},
	}
	
	
	@book{warren2013hacker,
	title={{Hacker's delight}},
	author={Warren, Henry S},
	year={2013},
	publisher={Pearson Education}
	}
	
	@article{fog2011instruction,
	title={{Instruction tables: Lists of instruction latencies, throughputs and micro-operation breakdowns for Intel, AMD and VIA CPUs}},
	author={Fog, Agner and others},
	journal={Copenhagen University College of Engineering},
	volume={97},
	pages={114},
	year={2011}
	}
	
	
	@article{guide2011intel,
	title={{Intel{\textregistered} 64 and IA-32 Architectures Software Developer’s Manual}},
	author={Guide, Part},
	journal={Volume 3B: System programming Guide, Part},
	volume={2},
	year={2011}
	}
	
	@inproceedings{keutzer2002asic,
	title={From ASIC to ASIP: The next design discontinuity},
	author={Keutzer, Kurt and Malik, Sharad and Newton, A Richard},
	booktitle={IEEE International Conference on Computer Design: VLSI in Computers and Processors},
	pages={84--90},
	year={2002}
	}
	
	
	@inproceedings{shao2014aladdin,
	title={{Aladdin: A pre-rtl, power-performance accelerator simulator enabling large design space exploration of customized architectures}},
	author={Shao, Yakun Sophia and Reagen, Brandon and Wei, Gu-Yeon and Brooks, David},
	booktitle={ACM/IEEE ISCA},
	volume={42},
	number={3},
	pages={97--108},
	year={2014}
	}
	
	@inproceedings{shao2013isa,
	title={{ISA-independent workload characterization and its implications for specialized architectures}},
	author={Shao, Yakun Sophia and Brooks, David},
	booktitle={IEEE International Symposium on Performance Analysis of Systems and Software (ISPASS)},
	pages={245--255},
	year={2013}
	}
	
	@book{book2010mentor,
	title={{High-level synthesis: blue book}},
	author={Fingeroff, Michael},
	year={2010},
	publisher={Mentor Graphics Corporation}
	}
	
	@book{alterac2h,
	title={{Nios II C2H Compiler}},
	author={Nios II C2H Compiler},
	year={2010},
	publisher={Altera Corporation (Intel)}
	}	
	
	
	@article{kim2015automated,
	title={{Automated iterative pipelining for ASIC design}},
	author={Kim, Lok-Won and Lee, Dong-U and Villasenor, John},
	journal={ACM Transactions on Design Automation of Electronic Systems (TODAES)},
	volume={20},
	number={2},
	pages={1--24},
	year={2015}
	}
	
	@article{ferrandi2010ant,
	title={Ant colony heuristic for mapping and scheduling tasks and communications on heterogeneous embedded systems},
	author={Ferrandi, Fabrizio and Lanzi, Pier Luca and Pilato, Christian and Sciuto, Donatella and Tumeo, Antonino},
	journal={IEEE Transactions on Computer-Aided Design of Integrated Circuits and Systems (TCAD)},
	volume={29},
	number={6},
	pages={911--924},
	year={2010}
	}
	
	@inproceedings{ganusov2016automated,
	title={Automated extra pipeline analysis of applications mapped to Xilinx UltraScale+ FPGAs},
	author={Ganusov, Ilya and Fraisse, Henri and Ng, Aaron and Possignolo, Rafael Trapani and Das, Sabya},
	booktitle={IEEE FPL},
	pages={1--10},
	year={2016}
	}
	
	@inproceedings{kim2013swsl,
	title={{SWSL: software synthesis for network lookup}},
	author={Kim, Sung Jin and De Carli, Lorenzo and Sankaralingam, Karthikeyan and Estan, Cristian},
	booktitle={ACM/IEEE ANCS},
	pages={191--202},
	year={2013}
	} 
	
	@inproceedings{harris2012leap,
	title={{LEAP: Latency-energy-and area-optimized lookup pipeline}},
	author={Harris, Eric N and Wasmundt, Samuel L and De Carli, Lorenzo and Sankaralingam, Karthikeyan and Estan, Cristian},
	booktitle={ACM/IEEE ANCS},
	pages={175--186},
	year={2012}
	} 
	
	@inproceedings{de2009plug,
	title={{PLUG: flexible lookup modules for rapid deployment of new protocols in high-speed routers}},
	author={De Carli, Lorenzo and Pan, Yi and Kumar, Amit and Estan, Cristian and Sankaralingam, Karthikeyan},
	booktitle={ACM SIGCOMM},
	pages={207--218},
	year={2009}
	}
	
	@inproceedings{pilato2013bambu,
	title={{Bambu: A modular framework for the high level synthesis of memory-intensive applications}},
	author={Pilato, Christian and Ferrandi, Fabrizio},
	booktitle={IEEE FPL},
	pages={1--4},
	year={2013}
	} 
	
	@inproceedings{canis2011legup,
	title={{LegUp: high-level synthesis for FPGA-based processor/accelerator systems}},
	author={Canis, Andrew and Choi, Jongsok and Aldham, Mark and Zhang, Victor and Kammoona, Ahmed and Anderson, Jason H and Brown, Stephen and Czajkowski, Tomasz},
	booktitle={ACM FPGA},
	pages={33--36},
	year={2011}
	}
	
	@book{book2010mentor,
	title={{High-level synthesis: blue book}},
	author={Fingeroff, Michael},
	year={2010},
	publisher={Mentor Graphics}
	} 
	
	@article{zilberman2014netfpga,
	title={{NetFPGA SUME: Toward 100 Gbps as research commodity}},
	author={Zilberman, Noa and Audzevich, Yury and Covington, G Adam and Moore, Andrew W},
	journal={IEEE micro},
	volume={34},
	number={5},
	pages={32--41},
	year={2014} 
	}
	
	@inproceedings{sultana2017emu,
	title={{Emu: Rapid prototyping of networking services}},
	author={Sultana, Nik and Galea, Salvator and Greaves, David and W{\'o}jcik, Marcin and Shipton, Jonny and Clegg, Richard and Mai, Luo and Bressana, Pietro and Soul{\'e}, Robert and Mortier, Richard and others},
	booktitle={USENIX ATC},
	pages={459--471},
	year={2017}
	}
	
	@inproceedings{ibanez2019p4,
	title={{The p4-> netfpga workflow for line-rate packet processing}},
	author={Ibanez, Stephen and Brebner, Gordon and McKeown, Nick and Zilberman, Noa},
	booktitle={ACM FPGA},
	pages={1--9},
	year={2019}
	} 
	
	@inproceedings{wang2017p4fpga,
	title={P4fpga: A rapid prototyping framework for p4},
	author={Wang, Han and Soul{\'e}, Robert and Dang, Huynh Tu and Lee, Ki Suh and Shrivastav, Vishal and Foster, Nate and Weatherspoon, Hakim}, 
	booktitle={ACM SOSR},
	pages={122--135},
	year={2017} 
	} 
	
	@inproceedings{li2016clicknp,
	title={Clicknp: Highly flexible and high performance network processing with reconfigurable hardware},
	author={Li, Bojie and Tan, Kun and Luo, Layong and Peng, Yanqing and Luo, Renqian and Xu, Ningyi and Xiong, Yongqiang and Cheng, Peng and Chen, Enhong},
	booktitle={ACM SIGCOMM},
	pages={1--14},
	year={2016}
	}
	
	@inproceedings{eran2019design,
	title={Design patterns for code reuse in HLS packet processing pipelines},
	author={Eran, Haggai and Zeno, Lior and Istv{\'a}n, Zsolt and Silberstein, Mark},
	booktitle={IEEE FCCM},
	pages={208--217},
	year={2019}
	}
	
	@inproceedings{li2011cacti,
	title={{CACTI-P: Architecture-level modeling for SRAM-based structures with advanced leakage reduction techniques}},
	author={Li, Sheng and Chen, Ke and Ahn, Jung Ho and Brockman, Jay B and Jouppi, Norman P},
	booktitle={ACM/IEEE ICCAD},
	pages={694--701},
	year={2011}
	}  
	
	@inproceedings{ajayi2019toward,
	title={{Toward an open-source digital flow: First learnings from the OpenROAD project}},
	author={Ajayi, Tutu and Chhabria, Vidya A and Foga{\c{c}}a, Mateus and Hashemi, Soheil and Hosny, Abdelrahman and Kahng, Andrew B and Kim, Minsoo and Lee, Jeongsup and Mallappa, Uday and Neseem, Marina and others},
	booktitle={ACM/IEEE DAC},
	pages={1--4},
	year={2019}
	}  
	
	@book{kahng2011vlsi,
	title={{VLSI physical design: from graph partitioning to timing closure}},
	author={Kahng, Andrew B and Lienig, Jens and Markov, Igor L and Hu, Jin},
	year={2011},
	publisher={Springer Science \& Business Media}
	}
	
	@phdthesis{ciccardi2019intelligent,
	title={{Intelligent Scheduler for Heterogeneous System on Chip}},
	author={Ciccardi, Andrea},
	year={2019}
	}
	
	@inproceedings{guthaus2016openram,
	title={{OpenRAM: An open-source memory compiler}},
	author={Guthaus, Matthew R and Stine, James E and Ataei, Samira and Chen, Brian and Wu, Bin and Sarwar, Mehedi},
	booktitle={IEEE/ACM ICCAD},
	pages={1--6},
	year={2016}
	}
	
	@inproceedings{ataei2017high,
	title={{A high performance multi-port SRAM for low voltage shared memory systems in 32 nm CMOS}},
	author={Ataei, Samira and Gaalswyk, Matthew and Stine, James E},
	booktitle={IEEE 60th International Midwest Symposium on Circuits and Systems (MWSCAS)},
	pages={1236--1239},
	year={2017}
	}
	
	@inproceedings{nichols2019automated,
	title={{Automated Synthesis of Multi-Port Memories and Control}},
	author={Nichols, Hunter and Grimes, Michael and Sowash, Jennifer and Cirimelli-Low, Jesse and Guthaus, Matthew R},
	booktitle={IFIP/IEEE VLSI-SoC},
	pages={59--64},
	year={2019}
	}
	
	@inproceedings{ming2012efficient,
	title={{An efficient and flexible embedded memory IP compiler}},
	author={Ming, Chen and Na, Bai},
	booktitle={IEEE International Conference on Cyber-Enabled Distributed Computing and Knowledge Discovery},
	pages={268--273},
	year={2012}
	}
	
	@inproceedings{ataei2019amc,
	title={{AMC: An asynchronous memory compiler}},
	author={Ataei, Samira and Manohar, Rajit},
	booktitle={IEEE ASYNC},
	pages={1--8},
	year={2019}
	}
	
	@inproceedings{goldman2014synopsys,
	title={{Synopsys' educational generic memory compiler}},
	author={Goldman, R and Bartleson, K and Wood, T and Melikyan, V and Babayan, E},
	booktitle={IEEE European Workshop on Microelectronics Education (EWME)},
	pages={89--92},
	year={2014}
	}
	
	@inproceedings{ramanarayanan20082,
	title={{A 2.1 ghz 6.5 mw 64-bit unified popcount/bitscan datapath unit for 65nm high-performance microprocessor execution cores}},
	author={Ramanarayanan, Rajaraman and Mathew, Sanu and Erraguntla, Vasantha and Krishnamurthy, Ram and Gueron, Shay},
	booktitle={IEEE International Conference on VLSI Design},
	pages={273--278},
	year={2008}
	}
	
	@inproceedings{sivaraman2016packet,
	title={{Packet transactions: High-level programming for line-rate switches}},
	author={Sivaraman, Anirudh and Cheung, Alvin and Budiu, Mihai and Kim, Changhoon and Alizadeh, Mohammad and Balakrishnan, Hari and Varghese, George and McKeown, Nick and Licking, Steve},
	booktitle={ACM SIGCOMM},
	pages={15--28},
	year={2016}
	}
	
	@article{bosshart2013forwarding,
	title={{Forwarding metamorphosis: Fast programmable match-action processing in hardware for SDN}},
	author={Bosshart, Pat and Gibb, Glen and Kim, Hun-Seok and Varghese, George and McKeown, Nick and Izzard, Martin and Mujica, Fernando and Horowitz, Mark},
	journal={ACM SIGCOMM},
	volume={43},
	number={4},
	pages={99--110},
	year={2013}
	}
	
	@inproceedings{choi2018fboss,
	title={{FBOSS: building switch software at scale}},
	author={Choi, Sean and Burkov, Boris and Eckert, Alex and Fang, Tian and Kazemkhani, Saman and Sherwood, Rob and Zhang, Ying and Zeng, Hongyi},
	booktitle={ACM SIGCOMM},
	pages={342--356},
	year={2018}
	}
	
	@article{yang2012practical,
	title={Practical multituple packet classification using dynamic discrete bit selection},
	author={Yang, Baohua and Fong, Jeffrey and Jiang, Weirong and Xue, Yibo and Li, Jun},
	journal={IEEE Transactions on Computers},
	volume={63},
	number={2},
	pages={424--434},
	year={2012}
	}
	
	@inproceedings{gibb2013design,
	title={Design principles for packet parsers},
	author={Gibb, Glen and Varghese, George and Horowitz, Mark and McKeown, Nick},
	booktitle={ACM/IEEE ANCS},
	pages={13--24},
	year={2013},
	}
	
	@article{qu2015high,
	title={High-performance and dynamically updatable packet classification engine on FPGA},
	author={Qu, Yun R and Prasanna, Viktor K},
	journal={IEEE Transactions on Parallel and Distributed Systems},
	volume={27},
	number={1},
	pages={197--209},
	year={2015}
	}
	
	@inproceedings{qu2013high,
	title={High-performance architecture for dynamically updatable packet classification on FPGA},
	author={Qu, Yun R and Zhou, Shijie and Prasanna, Viktor K},
	booktitle={ACM/IEEE ANCS},
	pages={125--136},
	year={2013}
	}
	
	@article{ganegedara2013scalable,
	title={A scalable and modular architecture for high-performance packet classification},
	author={Ganegedara, Thilan and Jiang, Weirong and Prasanna, Viktor K},
	journal={IEEE Transactions on Parallel and Distributed Systems},
	volume={25},
	number={5},
	pages={1135--1144},
	year={2013}
	}	 
	
	
	@article{jiang2011scalable,
	title={Scalable packet classification on FPGA},
	author={Jiang, Weirong and Prasanna, Viktor K},
	journal={IEEE Transactions on Very Large Scale Integration (VLSI) Systems},
	volume={20},
	number={9},
	pages={1668--1680},
	year={2011}
	}
	
	@inproceedings{tamimrcp,
	title={{Leveraging Domino to implement RCP in a stateful programmable pipeline}},
	author={Islam, Md Iftakharul and Khan, Javed I},
	booktitle={IEEE HPSR},
	year={2019}
	}
	
	@inproceedings{tamimc2rtl,
	title={{C2RTL: A high-level synthesis system for IP lookup and packet classification}},
	author={Islam, Md Iftakharul and Khan, Javed I},
	booktitle={IEEE HPSR},
	year={2021}
	}
	
	@inproceedings{narayana2017language,
	title={Language-directed hardware design for network performance monitoring},
	author={Narayana, Srinivas and Sivaraman, Anirudh and Nathan, Vikram and Goyal, Prateesh and Arun, Venkat and Alizadeh, Mohammad and Jeyakumar, Vimalkumar and Kim, Changhoon},
	booktitle={ACM SIGCOMM},
	pages={85--98},
	year={2017}
	}
	
	
	#TCAM
	@inproceedings{mcauley1993fast,
	title={{Fast routing table lookup using CAMs}},
	author={McAuley, Anthony J and Francis, Paul},
	booktitle={IEEE INFOCOM},
	volume={93},
	pages={1382--1391},
	year={1993},
	}
	
	@inproceedings{zane2003coolcams,
	title={{CoolCAMs: Power-efficient TCAMs for forwarding engines}},
	author={Zane, Francis and Narlikar, Girija and Basu, Anindya},
	booktitle={IEEE INFOCOM},
	volume={1},
	pages={42--52},
	year={2003},
	}
	
	@article{zheng2006tcam,
	title={{A TCAM-based distributed parallel IP lookup scheme and performance analysis}},
	author={Zheng, Kai and Hu, Chengchen and Lu, Hongbin and Liu, Bin},
	journal={IEEE/ACM Transactions on Networking},
	volume={14},
	number={4},
	pages={863--875},
	year={2006}
	}
	
	@article{akhbarizadeh2006tcam,
	title={{A TCAM-based parallel architecture for high-speed packet forwarding}},
	author={Akhbarizadeh, Mohammad J and Nourani, Mehrdad and Panigrahy, Rina and Sharma, Samar},
	journal={IEEE Transactions on Computers},
	volume={56},
	number={1},
	pages={58--72}
	}
	
	@article{ravikumar2004tcam,
	title={{TCAM architecture for IP lookup using prefix properties}},
	author={Ravikumar, VC and Mahapatra, Rabi N},
	journal={IEEE Micro},
	volume={24},
	number={2},
	pages={60--69},
	year={2004}
	}
	
	#Hash
	
	@inproceedings{kaxiras2005ipstash,
	title={{IPStash: a set-associative memory approach for efficient IP-lookup}},
	author={Kaxiras, Stefanos and Keramidas, Georgios},
	booktitle={IEEE INFOCOM},
	volume={2},
	pages={992--1001},
	year={2005}
	}
	
	@inproceedings{mantovani2020hl5,
	title={{HL5: A 32-bit RISC-V Processor Designed with High-Level Synthesis}},
	author={Mantovani, Paolo and Margelli, Robert and Giri, Davide and Carloni, Luca P},
	booktitle={2020 IEEE Custom Integrated Circuits Conference (CICC)},
	pages={1--8},
	year={2020},
	organization={IEEE}
	}
	
	@inproceedings{bando2009flashlook,
	title={{FlashLook: 100-gbps hash-tuned route lookup architecture}},
	author={Bando, Masanori and Artan, N Sertac and Chao, H Jonathan},
	booktitle={IEEE HPSR},
	pages={1--8},
	year={2009}
	}
	
	@inproceedings{hanna2009progressive,
	title={Progressive hashing for packet processing using set associative memory},
	author={Hanna, Michel and Demetriades, Socrates and Cho, Sangyeun and Melhem, Rami},
	booktitle={ACM/IEEE ANCS},
	pages={153--162},
	year={2009}
	}
	
	
	
	
	#Bloom filter
	
	@inproceedings{dharmapurikar2003longest,
	title={Longest prefix matching using bloom filters},
	author={Dharmapurikar, Sarang and Krishnamurthy, Praveen and Taylor, David E},
	booktitle={ACM SIGCOMM},
	pages={201--212},
	year={2003}
	}
	
	
	@inproceedings{song2009ipv6,
	title={{Ipv6 lookups using distributed and load balanced bloom filters for 100Gbps core router line cards}},
	author={Song, Haoyu and Hao, Fang and Kodialam, Murali and Lakshman, TV},
	booktitle={IEEE INFOCOM},
	pages={2518--2526},
	year={2009}
	}
	
	@article{song2005fast,
	title={{Fast hash table lookup using extended bloom filter: an aid to network processing}},
	author={Song, Haoyu and Dharmapurikar, Sarang and Turner, Jonathan and Lockwood, John},
	journal={ACM SIGCOMM Computer Communication Review},
	volume={35},
	number={4},
	pages={181--192},
	year={2005}
	} 
	
	@inproceedings{hasan2006chisel,
	title={{Chisel: A storage-efficient, collision-free hash-based network processing architecture}},
	author={Hasan, Jahangir and Cadambi, Srihari and Jakkula, Venkatta and Chakradhar, Srimat},
	booktitle={ACM/IEEE ISCA},
	pages={203--215},
	year={2006}
	}
	
	#pipelined ASIC
	
	@article{basu2005fast,
	title={{Fast incremental updates for pipelined forwarding engines}},
	author={Basu, Anindya and Narlikar, Girija},
	journal={IEEE/ACM Transactions on Networking},
	volume={13},
	number={3},
	pages={690--703},
	year={2005}
	}
	
	@inproceedings{basu2003fast,
	title={{Fast incremental updates for pipelined forwarding engines}},
	author={Basu, Anindya and Narlikar, Girija},
	booktitle={IEEE INFOCOM},
	pages={64--74},
	year={2003}
	}
	
	@inproceedings{jiang2008beyond,
	title={{Beyond TCAMs: An SRAM-based parallel multi-pipeline architecture for terabit IP lookup}},
	author={Jiang, Weirong and Wang, Qingbo and Prasanna, Viktor K},
	booktitle={IEEE INFOCOM},
	pages={1786--1794},
	year={2008}
	} 
	
	@article{jiang2012data,
	title={{Data structure optimization for power-efficient ip lookup architectures}},
	author={Jiang, Weirong and Prasanna, Viktor K},
	journal={IEEE Transactions on Computers},
	volume={62},
	number={11},
	pages={2169--2182},
	year={2012}
	}
	
	@article{tucker2009evolution,
	title={Evolution of WDM optical IP networks: A cost and energy perspective},
	author={Tucker, Rodney S and Parthiban, Rajendran and Baliga, Jayant and Hinton, Kerry and Ayre, Robert WA and Sorin, Wayne V},
	journal={IEEE Journal of Lightwave Technology},
	volume={27},
	number={3},
	pages={243--252},
	year={2009}
	}
	
	@inproceedings{kumar2006camp,
	title={{CAMP: fast and efficient IP lookup architecture}},
	author={Kumar, Sailesh and Becchi, Michela and Crowley, Patrick and Turner, Jonathan},
	booktitle={ACM/IEEE ANCS},
	pages={51--60},
	year={2006}
	}
	
	@inproceedings{hasan2005dynamic,
	title={{Dynamic pipelining: making IP-lookup truly scalable}},
	author={Hasan, Jahangir and Vijaykumar, TN},
	booktitle={ACM SIGCOMM},
	volume={35},
	number={4},
	pages={205--216},
	year={2005}
	}
	
	@inproceedings{baboescu2005tree,
	title={{A tree based router search engine architecture with single port memories}},
	author={Baboescu, Florin and Tullsen, Dean M and Rosu, Grigore and Singh, Sumeet},
	booktitle={ACM/IEEE ISCA},
	pages={123--133},
	year={2005}
	}
	
	#GPU
	
	@article{han2011packetshader,
	title={PacketShader: a GPU-accelerated software router},
	author={Han, Sangjin and Jang, Keon and Park, KyoungSoo and Moon, Sue},
	journal={ACM SIGCOMM},
	volume={41},
	number={4},
	pages={195--206},
	year={2011}
	}
	
	@inproceedings{li2013gamt,
	title={{GAMT: a fast and scalable IP lookup engine for GPU-based software routers}},
	author={Li, Yanbiao and Zhang, Dafang and Liu, Alex X and Zheng, Jintao},
	booktitle={ACM/IEEE ANCS},
	pages={1--12},
	year={2013}
	} 
	
	@inproceedings{sun2013fast,
	title={Fast and flexible: parallel packet processing with GPUs and click},
	author={Sun, Weibin and Ricci, Robert},
	booktitle={ACM/IEEE ANCS},
	pages={25--36},
	year={2013}
	}
	
	
	#Direct lookup
	
	@inproceedings{gupta1998routing,
	title={Routing lookups in hardware at memory access speeds},
	author={Gupta, Pankaj and Lin, Steven and McKeown, Nick},
	booktitle={IEEE INFOCOM},
	volume={3},
	pages={1240--1247},
	year={1998}
	}
	
	#Bitmap
	
	@article{degermark1997small,
	title={Small forwarding tables for fast routing lookups},
	author={Degermark, Mikael and Brodnik, Andrej and Carlsson, Svante and Pink, Stephen},
	journal={ACM SIGCOMM},
	volume={27},
	number={4},
	year={1997}
	}
	
	@inproceedings{srinivasan1998faster,
	title={{Faster IP lookups using controlled prefix expansion}},
	author={Srinivasan, Venkatachary and Varghese, George},
	booktitle={ACM SIGMETRICS},
	volume={26},
	number={1},
	pages={1--10},
	year={1998}
	} 
	
	@inproceedings{song2005shape,
	title={{Shape shifting tries for faster IP route lookup}},
	author={Song, Haoyu and Turner, Jonathan and Lockwood, John},
	booktitle={IEEE ICNP},
	pages={10--pp},
	year={2005}
	}
	
	@inproceedings{jacobson1989space,
	title={{Space-efficient static trees and graphs}},
	author={Jacobson, Guy},
	booktitle={IEEE Annual Symposium on Foundations of Computer Science},
	pages={549--554},
	year={1989}
	}
	
	
	@article{eatherton2004tree,
	title={{Tree bitmap: hardware/software IP lookups with incremental updates}},
	author={Eatherton, Will and Varghese, George and Dittia, Zubin},
	journal={ACM SIGCOMM Computer Communication Review},
	volume={34},
	number={2},
	pages={97--122},
	year={2004},
	}
	
	@article{bando2012flashtrie,
	title={{FlashTrie: beyond 100-Gb/s IP route lookup using hash-based prefix-compressed trie}},
	author={Bando, Masanori and Lin, Yi-Li and Chao, H Jonathan},
	journal={IEEE/ACM Transactions On Networking},
	volume={20},
	number={4},
	pages={1262--1275},
	year={2012}
	}
	
	@inproceedings{bando2010flashtrie,
	title={{FlashTrie: Hash-based prefix-compressed trie for IP route lookup beyond 100Gbps}},
	author={Bando, Masanori and Chao, H Jonathan},
	booktitle={IEEE INFOCOM},
	pages={1--9},
	year={2010}
	}
	
	@article{lara2010industry,
	title={{Industry's Highest Bandwidth FPGA Enables World's First Single-FPGA Solution for 400G Communications Line Cards}},
	author={Lara, Greg},
	journal={Xilinx White Paper: Vertex-7 Family},
	year={2010}
	}
	
	@article{schreiber2002pico,
	title={{PICO-NPA: High-level synthesis of nonprogrammable hardware accelerators}},
	author={Schreiber, Robert and Aditya, Shail and Mahlke, Scott and Kathail, Vinod and Rau, B Ramakrishna and Cronquist, Darren and Sivaraman, Mukund},
	journal={Journal of VLSI signal processing systems for signal, image and video technology},
	volume={31},
	number={2},
	pages={127--142},
	year={2002},
	publisher={Springer}
	}
	
	@article{stimpfling2019ship,
	title={{SHIP: A Scalable High-Performance IPv6 Lookup Algorithm That Exploits Prefix Characteristics}},
	author={Stimpfling, Thibaut and B{\'e}langer, Normand and Langlois, JM Pierre and Savaria, Yvon},
	journal={IEEE/ACM Transactions on Networking},
	volume={27},
	number={4},
	pages={1529--1542},
	year={2019}
	}
	
	@inproceedings{kondratyev2013share,
	title={{Share with care: A quantitative evaluation of sharing approaches in high-level synthesis}},
	author={Kondratyev, Alex and Lavagno, Luciano and Meyer, Mike and Watanabe, Yosinori},
	booktitle={IEEE DATE},
	pages={1547--1552},
	year={2013}
	}
	
	@inproceedings{sanguinetti2012transaction,
	title={{Transaction-accurate interface scheduling in high-level synthesis}},
	author={Sanguinetti, John and Meredith, Michael and Dart, Sean},
	booktitle={2012 Electronic System Level Synthesis Conference},
	pages={31--36},
	year={2012},
	organization={IEEE}
	}
	
	@inproceedings{yang2013architecture,
	title={{Architecture and performance models for scalable IP lookup engines on FPGA}},
	author={Yang, Yi-Hua E and Qu, Yun and Haria, Swapnil and Prasanna, Viktor K},
	booktitle={IEEE HPSR},
	pages={156--163},
	year={2013}
	}  
	
	@inproceedings{song2015scalable,
	title={{Scalable name-based packet forwarding: From millions to billions}},
	author={Song, Tian and Yuan, Haowei and Crowley, Patrick and Zhang, Beichuan},
	booktitle={ACM ICN},
	pages={19--28},
	year={2015}
	}
	
	
	@Book{lamport:94,
	author =	 {Lamport, Leslie},
	ALTeditor = 	 {},
	title = 	 {\LaTeX: A Document Preparation System},
	publisher = 	 {Addison-Wesley},
	year = 	 {1994},
	OPTkey = 	 {},
	OPTvolume = 	 {},
	OPTnumber = 	 {},
	OPTseries = 	 {},
	address =	 {Reading, Massachusetts},
	edition =	 {2nd},
	OPTmonth = 	 {},
	OPTnote = 	 {},
	OPTannote = 	 {}
	}
	@Book{mittelbach:goossens:04,
	author =	 {Mittelbach, Frank and Goossens, Michel},
	ALTeditor = 	 {},
	title = 	 {The \LaTeX\ Companion},
	publisher = 	 {Addison-Wesley},
	year = 	 {2004},
	OPTkey = 	 {},
	OPTvolume = 	 {},
	OPTnumber = 	 {},
	OPTseries = 	 {},
	address =	 {Boston},
	edition =	 {2nd},
	OPTmonth = 	 {},
	OPTnote = 	 {},
	OPTannote = 	 {}
	}
	
	
	
	@book{SystemC,
	title={System Design with SystemC},
	author={Gr{\"o}tker, Thorsten and Liao, Stan and Martin, Grant and Swan, Stuart},
	year={2007},
	publisher={Springer Science \& Business Media}
	}
	
	@MISC{iVerilog,
	key = {{Icarus Verilog}},
	title = {{Icarus Verilog}},
	note = {
	\url{http://iverilog.icarus.com/}
	},
	language = {english},
	}
	
	@MISC{SystemVerilog,
	key = {{IEEE 1800-2005 - IEEE Standard for SystemVerilog}},
	title = {{IEEE 1800-2005 - IEEE Standard for SystemVerilog}},
	note = {
	\url{https://standards.ieee.org/standard/1800-2005.html}
	},
	language = {english},
	}
	
	@misc{solutions2007handel,
	title={Handel-C Language Reference Manual. Agility Design Solutions},
	author={Solutions, Agility Design},
	year={2007}
	}
	
	@book{ku1990hardwarec,
	title={HardwareC--a language for hardware design (version 2.0)},
	author={Ku, David and DeMicheli, Giovanni},
	year={1990},
	publisher={Stanford University}
	}
	
	@MISC{evolutionhls,
	key = {The Evolution Of High-Level Synthesis},
	title = {The Evolution Of High-Level Synthesis},
	note = {
	\url{https://semiengineering.com/the-evolution-of-high-level-synthesis/}
	}
	} 
	
	@book{de1994synthesis,
	title={Synthesis and optimization of digital circuits},
	author={De Micheli, Giovanni},
	number={BOOK},
	year={1994},
	publisher={McGraw Hill}
	}
	
	@inproceedings{nane2012dwarv,
	title={DWARV 2.0: A CoSy-based C-to-VHDL hardware compiler},
	author={Nane, Razvan and Sima, Vlad-Mihai and Olivier, Bryan and Meeuws, Roel and Yankova, Yana and Bertels, Koen},
	booktitle={IEEE FPL},
	pages={619--622},
	year={2012}
	} 
	
	@inproceedings{minutoli2020soda,
	title={Soda: a new synthesis infrastructure for agile hardware design of machine learning accelerators},
	author={Minutoli, Marco and Castellana, Vito Giovanni and Tan, Cheng and Manzano, Joseph and Amatya, Vinay and Tumeo, Antonino and Brooks, David and Wei, Gu-Yeon},
	booktitle={IEEE/ACM ICCAD},
	pages={1--7},
	year={2020}
	}
	
	@inproceedings{venkatesan2019magnet,
	title={Magnet: A modular accelerator generator for neural networks},
	author={Venkatesan, Rangharajan and Shao, Yakun Sophia and Wang, Miaorong and Clemons, Jason and Dai, Steve and Fojtik, Matthew and Keller, Ben and Klinefelter, Alicia and Pinckney, Nathaniel and Raina, Priyanka and others},
	booktitle={IEEE/ACM ICCAD},
	pages={1--8},
	year={2019}
	}
	
	@article{nane2015survey,
	title={A survey and evaluation of FPGA high-level synthesis tools},
	author={Nane, Razvan and Sima, Vlad-Mihai and Pilato, Christian and Choi, Jongsok and Fort, Blair and Canis, Andrew and Chen, Yu Ting and Hsiao, Hsuan and Brown, Stephen and Ferrandi, Fabrizio and others},
	journal={IEEE Transactions on Computer-Aided Design of Integrated Circuits and Systems (TCAD)},
	volume={35},
	number={10},
	pages={1591--1604},
	year={2015}
	}
	
	@MISC{Bluespec,
	key = {{Bluespec}},
	title = {{Bluespec}},
	note = {
	\url{https://bluespec.com/}
	},
	language = {english},
	}
	
	@MISC{ssawiki,
	key = {{Static Single Assignment (SSA) form}},
	title = {{Static Single Assignment (SSA) form}},
	note = {
	\url{https://en.wikipedia.org/wiki/Static_single_assignment_form}
	},
	language = {english},
	}
	
	@MISC{ssagcc,
	key = {{Static Single Assignment (SSA) in GCC}},
	title = {{Static Single Assignment (SSA) in GCC}},
	note = {
	\url{https://gcc.gnu.org/onlinedocs/gcc-4.3.4/gccint/SSA.html}
	},
	language = {english},
	}
	
	@MISC{GCCplugin,
	key = {{GCC Plugin}},
	title = {{GCC Plugin}},
	note = {
	\url{https://gcc.gnu.org/wiki/GCC_Plugins}
	},
	language = {english},
	}
	
	
	@MISC{CiscoAsic,
	key = {{Cisco Enterprise Silicon}},
	title = {{Cisco Enterprise Silicon}},
	note = {
	\url{https://www.ciscolive.com/c/dam/r/ciscolive/us/docs/2017/pdf/BRKARC-3467.pdf}
	},
	language = {english},
	}
	
	
	@article{hwang1991formal,
	title={{A formal approach to the scheduling problem in high level synthesis}},
	author={Hwang, C-T and Lee, J-H and Hsu, Y-C},
	journal={IEEE Transactions on Computer-Aided Design of Integrated Circuits and Systems (TCAD)},
	volume={10},
	number={4},
	pages={464--475},
	year={1991}
	}
	
	@inproceedings{lantz2010network,
	title={{A network in a laptop: rapid prototyping for software-defined networks}},
	author={Lantz, Bob and Heller, Brandon and McKeown, Nick},
	booktitle={ACM SIGCOMM HotNet},
	year={2010},
	}
	
	@article{bosshart2014p4,
	title={{P4: Programming protocol-independent packet processors}},
	author={Bosshart, Pat and Daly, Dan and Gibb, Glen and Izzard, Martin and McKeown, Nick and Rexford, Jennifer and Schlesinger, Cole and Talayco, Dan and Vahdat, Amin and Varghese, George and others},
	journal={ACM SIGCOMM CCR},
	volume={44},
	number={3},
	pages={87--95},
	year={2014},
	}
	
	
	@inproceedings{kondratyev2011realistic,
	title={Realistic performance-constrained pipelining in high-level synthesis},
	author={Kondratyev, Alex and Lavagno, Luciano and Meyer, Mike and Watanabe, Yosinori},
	booktitle={IEEE DATE},
	pages={1--6},
	year={2011}
	}
	
	@incollection{coussy2008gaut,
	title={{GAUT: A high-level synthesis tool for DSP applications}},
	author={Coussy, Philippe and Chavet, Cyrille and Bomel, Pierre and Heller, Dominique and Senn, Eric and Martin, Eric},
	booktitle={High-Level Synthesis},
	pages={147--169},
	year={2008},
	publisher={Springer}
	}
	
	
	@article{coussy2009introduction,
	title={An introduction to high-level synthesis},
	author={Coussy, Philippe and Gajski, Daniel D and Meredith, Michael and Takach, Andres},
	journal={IEEE Design \& Test of Computers},
	volume={26},
	number={4},
	pages={8--17},
	year={2009}
	}
	
	@inproceedings{khailany2018modular,
	title={{A modular digital VLSI flow for high-productivity SoC design}},
	author={Khailany, Brucek and Krimer, Evgeni and Venkatesan, Rangharajan and Clemons, Jason and Emer, Joel S and Fojtik, Matthew and Klinefelter, Alicia and Pellauer, Michael and Pinckney, Nathaniel and Shao, Yakun Sophia and others},
	booktitle={ACM/IEEE DAC},
	pages={1--6},
	year={2018}
	}
	
	@inproceedings{mantovani2020agile,
	title={{Agile SoC development with open ESP}},
	author={Mantovani, Paolo and Giri, Davide and Di Guglielmo, Giuseppe and Piccolboni, Luca and Zuckerman, Joseph and Cota, Emilio G and Petracca, Michele and Pilato, Christian and Carloni, Luca P},
	booktitle={IEEE/ACM ICCAD},
	pages={1--9},
	year={2020}
	}
	
	@inproceedings{openlane,
	title={{OpenLANE: The open-source digital ASIC implementation flow}},
	author={Ghazy, Ahmed A. and Shalan, Mohamed},
	booktitle={WOSET},
	year={2020}
	}
	
	@inproceedings{cong2006efficient,
	title={{An efficient and versatile scheduling algorithm based on SDC formulation}},
	author={Cong, Jason and Zhang, Zhiru},
	booktitle={2006 43rd ACM/IEEE Design Automation Conference},
	pages={433--438},
	year={2006},
	organization={IEEE}
	}
	
	@article{rojas2015helix,
	title={{Helix: IP lookup scheme based on helicoidal properties of binary trees}},
	author={Rojas-Cessa, Roberto and Kijkanjanarat, Taweesak and Wangchai, Wara and Patil, Krutika and Thirapittayatakul, Narathip},
	journal={Computer Networks},
	volume={89},
	pages={78--89},
	year={2015},
	publisher={Elsevier}
	} 
	
	@inproceedings{rojas2007parallel,
	title={Parallel search trie-based scheme for fast IP lookup},
	author={Rojas-Cessa, Roberto and Ramesh, Lakshmi and Dong, Ziqian and Cai, Lin and Ansari, Nirwan},
	booktitle={IEEE GLOBECOM},
	pages={210--214},
	year={2007}
	}
	
	
	@inproceedings{kondratyev2012exploiting,
	title={{Exploiting area/delay tradeoffs in high-level synthesis}},
	author={Kondratyev, Alex and Lavagno, Luciano and Meyer, Mike and Watanabe, Yosinori},
	booktitle={IEEE DATE},
	pages={1024--1029},
	year={2012}
	} 
	
	@inproceedings{vaish2011experiences,
	title={Experiences in co-designing a packet classification algorithm and a flexible hardware platform},
	author={Vaish, Nilay and Kooburat, Thawan and De Carli, Lorenzo and Sankaralingam, Karthikeyan and Estan, Cristian},
	booktitle={ACM/IEEE ANCS},
	pages={189--199},
	year={2011}
	}
	
	@inproceedings{fadishei2005novel,
	title={{A novel reconfigurable hardware architecture for IP address lookup}},
	author={Fadishei, Hamid and Zamani, Morteza Saheb and Sabaei, Masoud},
	booktitle={ACM/IEEE ANCS},
	pages={81--90},
	year={2005}
	}
	
	@inproceedings{le2008sram,
	title={A sram-based architecture for trie-based ip lookup using fpga},
	author={Le, Hoang and Jiang, Weirong and Prasanna, Viktor K},
	booktitle={IEEE FCCM},
	pages={33--42},
	year={2008}
	}
	
	@article{sangireddy2005scalable,
	title={Scalable, memory efficient, high-speed IP lookup algorithms},
	author={Sangireddy, Rama and Futamura, Natsuhiko and Aluru, Srinivas and Somani, Arun K},
	journal={IEEE/ACM Transactions on Networking},
	volume={13},
	number={4},
	pages={802--812},
	year={2005}
	}
	
	@inproceedings{meribout2003new,
	title={A new hardware algorithm for fast IP routing targeting programmable routers},
	author={Meribout, Mahmoud and Motomura, Massato},
	booktitle={International Conference on Network Control and Engineering for QoS, Security and Mobility},
	pages={164--179},
	year={2003},
	organization={Springer}
	}
	
	@article{pao2014ip,
	title={IP address lookup using bit-shuffled trie},
	author={Pao, Derek and Lu, Ziyan and Poon, Yat Hang},
	journal={Computer communications},
	volume={47},
	pages={51--64},
	year={2014},
	publisher={Elsevier}
	}
	
	
	@inproceedings{hara2008chstone,
	title={Chstone: A benchmark program suite for practical c-based high-level synthesis},
	author={Hara, Yuko and Tomiyama, Hiroyuki and Honda, Shinya and Takada, Hiroaki and Ishii, Katsuya},
	booktitle={IEEE ISCAS},
	pages={1192--1195},
	year={2008}
	}
	
	@article{schafer2014s2cbench,
	title={S2cbench: Synthesizable systemc benchmark suite for high-level synthesis},
	author={Schafer, Benjamin Carrion and Mahapatra, Anushree},
	journal={IEEE Embedded Systems Letters},
	volume={6},
	number={3},
	pages={53--56},
	year={2014}
	}
	
	
	@article{lattuada2019design,
	title={A design flow engine for the support of customized dynamic high level synthesis flows},
	author={Lattuada, Marco and Ferrandi, Fabrizio},
	journal={ACM Transactions on Reconfigurable Technology and Systems (TRETS)},
	volume={12},
	number={4},
	pages={1--26},
	year={2019}
	}
	
	@article{chen2005xpilot,
	title={{xPilot: A platform-based behavioral synthesis system}},
	author={Chen, Deming and Cong, Jason and Fan, Yiping and Han, Guoling and Jiang, Wei and Zhang, Zhiru},
	journal={SRC TechCon},
	volume={5},
	year={2005}
	}
	
	@article{cong2011high,
	title={{High-level synthesis for FPGAs: From prototyping to deployment}},
	author={Cong, Jason and Liu, Bin and Neuendorffer, Stephen and Noguera, Juanjo and Vissers, Kees and Zhang, Zhiru},
	journal={IEEE Transactions on Computer-Aided Design of Integrated Circuits and Systems (TCAD)},
	volume={30},
	number={4},
	pages={473--491},
	year={2011}
	} 
	
	@article{guo2008compiler,
	title={{A compiler intermediate representation for reconfigurable fabrics}},
	author={Guo, Zhi and Buyukkurt, Betul and Cortes, John and Mitra, Abhishek and Najjar, Walild},
	journal={International Journal of Parallel Programming},
	volume={36},
	number={5},
	pages={493--520},
	year={2008},
	publisher={Springer}
	}
	
	@inproceedings{villarreal2010designing,
	title={Designing modular hardware accelerators in C with ROCCC 2.0},
	author={Villarreal, Jason and Park, Adrian and Najjar, Walid and Halstead, Robert},
	booktitle={IEEE FCCM},
	pages={127--134},
	year={2010}
	}
	
	@book{gupta2007spark,
	title={{SPARK: a parallelizing approach to the high-level synthesis of digital circuits}},
	author={Gupta, Sumit and Gupta, Rajesh and Dutt, Nikil D and Nicolau, Alexandru},
	year={2007},
	publisher={Springer Science \& Business Media}
	}
	
	@inproceedings{budiu2004spatial,
	title={Spatial computation},
	author={Budiu, Mihai and Venkataramani, Girish and Chelcea, Tiberiu and Goldstein, Seth Copen},
	booktitle={ACM ASPLOS},
	pages={14--26},
	year={2004}
	}
	
	@article{mencer2006asc,
	title={{ASC: a stream compiler for computing with FPGAs}},
	author={Mencer, Oskar},
	journal={IEEE Transactions on Computer-Aided Design of Integrated Circuits and Systems (TCAD)},
	volume={25},
	number={9},
	pages={1603--1617},
	year={2006}
	}
	
	@article{zheng2014high,
	title={{High-level synthesis with behavioral-level multicycle path analysis}},
	author={Zheng, Hongbin and Gurumani, Swathi T and Yang, Liwei and Chen, Deming and Rupnow, Kyle},
	journal={IEEE Transactions on Computer-Aided Design of Integrated Circuits and Systems (TCAD)},
	volume={33},
	number={12},
	pages={1832--1845},
	year={2014}
	}
	
	@inproceedings{jiang2009large,
	title={{Large-scale wire-speed packet classification on FPGAs}},
	author={Jiang, Weirong and Prasanna, Viktor K},
	booktitle={ACM FPGA},
	pages={219--228},
	year={2009}
	} 
	
	@inproceedings{li2013hybridcuts,
	title={{HybridCuts: A scheme combining decomposition and cutting for packet classification}},
	author={Li, Wenjun and Li, Xianfeng},
	booktitle={IEEE High-Performance Interconnects},
	pages={41--48},
	year={2013}
	}
	
	@book{chao2007high,
	title={High performance switches and routers},
	author={Chao, H Jonathan and Liu, Bin},
	year={2007},
	publisher={John Wiley \& Sons}
	}
	
	@inproceedings{rashelbach2020computational,
	title={A computational approach to packet classification},
	author={Rashelbach, Alon and Rottenstreich, Ori and Silberstein, Mark},
	booktitle={ACM SIGCOMM},
	pages={542--556},
	year={2020}
	}
	
	@article{song2012abc,
	title={{ABC: Adaptive binary cuttings for multidimensional packet classification}},
	author={Song, Haoyu and Turner, Jonathan S},
	journal={IEEE/ACM Transactions On Networking},
	volume={21},
	number={1},
	pages={98--109},
	year={2012}
	}
	
	@article{li2020tuple,
	title={{Tuple space assisted packet classification with high performance on both search and update}},
	author={Li, Wenjun and Yang, Tong and Rottenstreich, Ori and Li, Xianfeng and Xie, Gaogang and Li, Hui and Vamanan, Balajee and Li, Dagang and Lin, Huiping},
	journal={IEEE Journal on Selected Areas in Communications (JSAC)},
	volume={38},
	number={7},
	pages={1555--1569},
	year={2020}
	} 
	
	@article{lahti2018we,
	title={{Are we there yet? A study on the state of high-level synthesis}},
	author={Lahti, Sakari and Sj{\"o}vall, Panu and Vanne, Jarno and H{\"a}m{\"a}l{\"a}inen, Timo D},
	journal={IEEE Transactions on Computer-Aided Design of Integrated Circuits and Systems (TCAD)},
	volume={38},
	number={5},
	pages={898--911},
	year={2018}
	}
	
	@inproceedings{sivaraman2015towards,
	title={Towards programmable packet scheduling},
	author={Sivaraman, Anirudh and Subramanian, Suvinay and Agrawal, Anurag and Chole, Sharad and Chuang, Shang-Tse and Edsall, Tom and Alizadeh, Mohammad and Katti, Sachin and McKeown, Nick and Balakrishnan, Hari},
	booktitle={ACM SIGCOMM},
	pages={1--7},
	year={2015}
	}
	
	
	@inproceedings{tamimcptrie,
	title={{CP-Trie: Cumulative PopCount based Trie for IPv6 Routing Table Lookup in Software and ASIC}},
	author={Islam, MD Iftakharul and Khan, Javed I},
	booktitle={IEEE HPSR},
	year={2021}
	}
	
	@inproceedings{islam2017network,
	title={{A network-centric TCP for interactive video delivery networks (VDN)}},
	author={Islam, Md Iftakharul and Khan, Javed I},
	booktitle={IEEE ICNP},
	pages={1--6},
	year={2017}
	}
	
	@book{gajski2012specc,
	title={SpecC: Specification language and methodology},
	author={Gajski, Daniel D and Zhu, Jianwen and D{\"o}mer, Rainer and Gerstlauer, Andreas and Zhao, Shuqing},
	year={2012},
	publisher={Springer Science \& Business Media}
	}
	
	@inproceedings{li2018cutsplit,
	title={{Cutsplit: A decision-tree combining cutting and splitting for scalable packet classification}},
	author={Li, Wenjun and Li, Xianfeng and Li, Hui and Xie, Gaogang},
	booktitle={IEEE INFOCOM},
	pages={2645--2653},
	year={2018}
	}
	
	@inproceedings{li2019tabtree,
	title={{TabTree: A TSS-assisted bit-selecting tree scheme for packet classification with balanced rule mapping}},
	author={Li, Wenjun and Yang, Tong and Chang, Yeim-Kuan and Li, Tao and Li, Hui},
	booktitle={ACM/IEEE ANCS},
	pages={1--8},
	year={2019}
	}
	
	@inproceedings{hsieh2016many,
	title={Many-field packet classification for software-defined networking switches},
	author={Hsieh, Cheng-Liang and Weng, Ning},
	booktitle={ACM/IEEE ANCS},
	pages={13--24},
	year={2016}
	}
	
	@inproceedings{minutoli2020soda,
	title={{SODA: a new synthesis infrastructure for agile hardware design of machine learning accelerators}},
	author={Minutoli, Marco and Castellana, Vito Giovanni and Tan, Cheng and Manzano, Joseph and Amatya, Vinay and Tumeo, Antonino and Brooks, David and Wei, Gu-Yeon},
	booktitle={IEEE/ACM ICCAD},
	pages={1--7},
	year={2020}
	}
	
	@inproceedings{antichi2014ja,
	title={{JA-trie: Entropy-based packet classification}},
	author={Antichi, Gianni and Callegari, Christian and Moore, Andrew W and Giordano, Stefano and Anastasi, Enrico},
	booktitle={IEEE HPSR},
	pages={32--37},
	year={2014}
	}
	
	@inproceedings{srinivasan1999packet,
	title={Packet classification using tuple space search},
	author={Srinivasan, Venkatachary and Suri, Subhash and Varghese, George},
	booktitle={ACM SIGCOMM},
	pages={135--146},
	year={1999}
	}
	
	@inproceedings{pfaff2015design,
	title={The design and implementation of open vswitch},
	author={Pfaff, Ben and Pettit, Justin and Koponen, Teemu and Jackson, Ethan and Zhou, Andy and Rajahalme, Jarno and Gross, Jesse and Wang, Alex and Stringer, Joe and Shelar, Pravin and others},
	booktitle={USENIX NSDI},
	pages={117--130},
	year={2015}
	}
	
	@inproceedings{tripp2005trident,
	title={{Trident: an FPGA compiler framework for floating-point algorithms}},
	author={Tripp, Justin L and Peterson, Kristopher D and Ahrens, Christine and Poznanovic, Jeffrey D and Gokhale, Maya B},
	booktitle={IEEE FPL, 2005.},
	pages={317--322},
	year={2005},
	}
	
	@book{elliott1999understanding,
	title={{Understanding behavioral synthesis: a practical guide to high-level design}},
	author={Elliott, John P},
	year={1999},
	publisher={Springer Science \& Business Media}
	}
	
	@book{knapp1996behavioral,
	title={Behavioral synthesis: digital system design using the synopsys behavioral compiler},
	author={Knapp, David W},
	year={1996},
	publisher={Prentice-Hall, Inc.}
	}
	
	@inproceedings{khouri1998impact,
	title={{IMPACT: A high-level synthesis system for low power control-flow intensive circuits}},
	author={Khouri, Kamal S and Lakshminarayana, Ganesh and Jha, Niraj K},
	booktitle={IEEE DATE},
	pages={848--854},
	year={1998}
	}
	
	@book{book2010mentor,
	title={{High-level synthesis: blue book}},
	author={Fingeroff, Michael},
	year={2010},
	publisher={Xlibris Corporation}
	}
	
	@article{zilberman2014netfpga,
	title={{NetFPGA SUME: Toward 100 Gbps as research commodity}},
	author={Zilberman, Noa and Audzevich, Yury and Covington, G Adam and Moore, Andrew W},
	journal={IEEE micro},
	volume={34},
	number={5},
	pages={32--41},
	year={2014}
	} 
	
	@inproceedings{ataei2017high,
	title={{A high performance multi-port SRAM for low voltage shared memory systems in 32 nm CMOS}},
	author={Ataei, Samira and Gaalswyk, Matthew and Stine, James E},
	booktitle={IEEE 60th International Midwest Symposium on Circuits and Systems (MWSCAS)},
	pages={1236--1239},
	year={2017}
	}
	
	@inproceedings{nichols2019automated,
	title={{Automated Synthesis of Multi-Port Memories and Control}},
	author={Nichols, Hunter and Grimes, Michael and Sowash, Jennifer and Cirimelli-Low, Jesse and Guthaus, Matthew R},
	booktitle={IFIP/IEEE 27th International Conference on Very Large Scale Integration (VLSI-SoC)},
	pages={59--64},
	year={2019}
	}
	
	
	@inproceedings{li2011cacti,
	title={{CACTI-P: Architecture-level modeling for SRAM-based structures with advanced leakage reduction techniques}},
	author={Li, Sheng and Chen, Ke and Ahn, Jung Ho and Brockman, Jay B and Jouppi, Norman P},
	booktitle={ACM/IEEE ICCAD},
	pages={694--701},
	year={2011}
	}
	
	@inproceedings{lattuada2015code,
	title={{Code transformations based on speculative SDC scheduling}},
	author={Lattuada, Marco and Ferrandi, Fabrizio},
	booktitle={IEEE/ACM ICCAD},
	pages={71--77},
	year={2015}
	}
	
	@inproceedings{ajayi2019toward,
	title={{Toward an open-source digital flow: First learnings from the OpenROAD project}},
	author={Ajayi, Tutu and Chhabria, Vidya A and Foga{\c{c}}a, Mateus and Hashemi, Soheil and Hosny, Abdelrahman and Kahng, Andrew B and Kim, Minsoo and Lee, Jeongsup and Mallappa, Uday and Neseem, Marina and others},
	booktitle={ACM/IEEE DAC},
	pages={1--4},
	year={2019}
	}
	
	@book{kahng2011vlsi,
	title={{VLSI physical design: from graph partitioning to timing closure}},
	author={Kahng, Andrew B and Lienig, Jens and Markov, Igor L and Hu, Jin},
	year={2011},
	publisher={Springer Science \& Business Media}
	}
	
	@phdthesis{ciccardi2019intelligent,
	title={{Intelligent Scheduler for Heterogeneous System on Chip}},
	author={Ciccardi, Andrea},
	year={2019}
	}
	
	@inproceedings{guthaus2016openram,
	title={{OpenRAM: An open-source memory compiler}},
	author={Guthaus, Matthew R and Stine, James E and Ataei, Samira and Chen, Brian and Wu, Bin and Sarwar, Mehedi},
	booktitle={IEEE/ACM ICCAD},
	pages={1--6},
	year={2016}
	}
	
	@inproceedings{ming2012efficient,
	title={{An efficient and flexible embedded memory IP compiler}},
	author={Ming, Chen and Na, Bai},
	booktitle={IEEE International Conference on Cyber-Enabled Distributed Computing and Knowledge Discovery},
	pages={268--273},
	year={2012}
	}
	
	@inproceedings{ataei2019amc,
	title={{AMC: An asynchronous memory compiler}},
	author={Ataei, Samira and Manohar, Rajit},
	booktitle={IEEE ASYNC},
	pages={1--8},
	year={2019}
	}
	
	@inproceedings{goldman2014synopsys,
	title={{Synopsys' educational generic memory compiler}},
	author={Goldman, R and Bartleson, K and Wood, T and Melikyan, V and Babayan, E},
	booktitle={IEEE European Workshop on Microelectronics Education (EWME)},
	pages={89--92},
	year={2014}
	}
	
	@inproceedings{ramanarayanan20082,
	title={{A 2.1 ghz 6.5 mw 64-bit unified popcount/bitscan datapath unit for 65nm high-performance microprocessor execution cores}},
	author={Ramanarayanan, Rajaraman and Mathew, Sanu and Erraguntla, Vasantha and Krishnamurthy, Ram and Gueron, Shay},
	booktitle={IEEE International Conference on VLSI Design},
	pages={273--278},
	year={2008}
	}
	
	@inproceedings{sivaraman2016packet,
	title={{Packet transactions: High-level programming for line-rate switches}},
	author={Sivaraman, Anirudh and Cheung, Alvin and Budiu, Mihai and Kim, Changhoon and Alizadeh, Mohammad and Balakrishnan, Hari and Varghese, George and McKeown, Nick and Licking, Steve},
	booktitle={ACM SIGCOMM},
	pages={15--28},
	year={2016}
	}
	
	@inproceedings{gao2020switch,
	title={Switch code generation using program synthesis},
	author={Gao, Xiangyu and Kim, Taegyun and Wong, Michael D and Raghunathan, Divya and Varma, Aatish Kishan and Kannan, Pravein Govindan and Sivaraman, Anirudh and Narayana, Srinivas and Gupta, Aarti},
	booktitle={ACM SIGCOMM},
	pages={44--61},
	year={2020}
	}
	
	@inproceedings{gao2020lyra,
	title={{Lyra: A Cross-Platform Language and Compiler for Data Plane Programming on Heterogeneous ASICs}},
	author={Gao, Jiaqi and Zhai, Ennan and Liu, Hongqiang Harry and Miao, Rui and Zhou, Yu and Tian, Bingchuan and Sun, Chen and Cai, Dennis and Zhang, Ming and Yu, Minlan},
	booktitle={ACM SIGCOMM},
	pages={435--450},
	year={2020}
	}
	
	@article{bosshart2013forwarding,
	title={{Forwarding metamorphosis: Fast programmable match-action processing in hardware for SDN}},
	author={Bosshart, Pat and Gibb, Glen and Kim, Hun-Seok and Varghese, George and McKeown, Nick and Izzard, Martin and Mujica, Fernando and Horowitz, Mark},
	journal={ACM SIGCOMM},
	volume={43},
	number={4},
	pages={99--110},
	year={2013}
	}
	
	@inproceedings{choi2018fboss,
	title={{FBOSS: building switch software at scale}},
	author={Choi, Sean and Burkov, Boris and Eckert, Alex and Fang, Tian and Kazemkhani, Saman and Sherwood, Rob and Zhang, Ying and Zeng, Hongyi},
	booktitle={ACM SIGCOMM},
	pages={342--356},
	year={2018}
	}
	
	@inproceedings{gibb2013design,
	title={Design principles for packet parsers},
	author={Gibb, Glen and Varghese, George and Horowitz, Mark and McKeown, Nick},
	booktitle={ACM/IEEE ANCS},
	pages={13--24},
	year={2013},
	}
	
	
	@inproceedings{tamimsail,
	title={{SAIL Based FIB Lookup in a Programmable Pipeline Based Linux Router}},
	author={Islam, Md Iftakharul and Khan, Javed I},
	booktitle={IEEE International Conference on High Performance Switching and Routing (HPSR)},
	year={2019}
	}
	
	@inproceedings{tamimrcp,
	title={{Leveraging Domino to Implement RCP in a Stateful Programmable Pipeline}},
	author={Islam, Md Iftakharul and Khan, Javed I},
	booktitle={IEEE International Conference on High Performance Switching and Routing (HPSR)},
	year={2019}
	}
	
	@inproceedings{narayana2017language,
	title={Language-directed hardware design for network performance monitoring},
	author={Narayana, Srinivas and Sivaraman, Anirudh and Nathan, Vikram and Goyal, Prateesh and Arun, Venkat and Alizadeh, Mohammad and Jeyakumar, Vimalkumar and Kim, Changhoon},
	booktitle={ACM SIGCOMM},
	pages={85--98},
	year={2017}
	}
	
	
	#TCAM
	@inproceedings{mcauley1993fast,
	title={{Fast routing table lookup using CAMs}},
	author={McAuley, Anthony J and Francis, Paul},
	booktitle={IEEE INFOCOM},
	volume={93},
	pages={1382--1391},
	year={1993},
	}
	
	@inproceedings{zane2003coolcams,
	title={{CoolCAMs: Power-efficient TCAMs for forwarding engines}},
	author={Zane, Francis and Narlikar, Girija and Basu, Anindya},
	booktitle={IEEE INFOCOM},
	volume={1},
	pages={42--52},
	year={2003},
	}
	
	@article{zheng2006tcam,
	title={{A TCAM-based distributed parallel IP lookup scheme and performance analysis}},
	author={Zheng, Kai and Hu, Chengchen and Lu, Hongbin and Liu, Bin},
	journal={IEEE/ACM Transactions on Networking},
	volume={14},
	number={4},
	pages={863--875},
	year={2006},
	publisher={IEEE}
	}
	
	@article{akhbarizadeh2006tcam,
	title={{A TCAM-based parallel architecture for high-speed packet forwarding}},
	author={Akhbarizadeh, Mohammad J and Nourani, Mehrdad and Panigrahy, Rina and Sharma, Samar},
	journal={IEEE Transactions on Computers},
	volume={56},
	number={1},
	pages={58--72},
	year={2006}
	}
	
	#Hash
	
	@inproceedings{kaxiras2005ipstash,
	title={{IPStash: a set-associative memory approach for efficient IP-lookup}},
	author={Kaxiras, Stefanos and Keramidas, Georgios},
	booktitle={IEEE INFOCOM},
	volume={2},
	pages={992--1001},
	year={2005}
	}
	
	
	@inproceedings{bando2009flashlook,
	title={{FlashLook: 100-gbps hash-tuned route lookup architecture}},
	author={Bando, Masanori and Artan, N Sertac and Chao, H Jonathan},
	booktitle={IEEE HPSR},
	pages={1--8},
	year={2009}
	}
	
	@inproceedings{hanna2009progressive,
	title={Progressive hashing for packet processing using set associative memory},
	author={Hanna, Michel and Demetriades, Socrates and Cho, Sangyeun and Melhem, Rami},
	booktitle={ACM/IEEE ANCS},
	pages={153--162},
	year={2009}
	}
	
	
	
	
	#Bloom filter
	
	@inproceedings{dharmapurikar2003longest,
	title={Longest prefix matching using bloom filters},
	author={Dharmapurikar, Sarang and Krishnamurthy, Praveen and Taylor, David E},
	booktitle={ACM SIGCOMM},
	pages={201--212},
	year={2003}
	}
	
	
	@inproceedings{song2009ipv6,
	title={{Ipv6 lookups using distributed and load balanced bloom filters for 100Gbps core router line cards}},
	author={Song, Haoyu and Hao, Fang and Kodialam, Murali and Lakshman, TV},
	booktitle={IEEE INFOCOM},
	pages={2518--2526},
	year={2009}
	}
	
	
	@inproceedings{hasan2006chisel,
	title={{Chisel: A storage-efficient, collision-free hash-based network processing architecture}},
	author={Hasan, Jahangir and Cadambi, Srihari and Jakkula, Venkatta and Chakradhar, Srimat},
	booktitle={ACM/IEEE ISCA},
	pages={203--215},
	year={2006}
	}
	
	@inproceedings{bachrach2012chisel,
	title={{Chisel: constructing hardware in a scala embedded language}},
	author={Bachrach, Jonathan and Vo, Huy and Richards, Brian and Lee, Yunsup and Waterman, Andrew and Avi{\v{z}}ienis, Rimas and Wawrzynek, John and Asanovi{\'c}, Krste},
	booktitle={ACM/IEEE DAC},
	pages={1212--1221},
	year={2012}
	}
	
	@inproceedings{lockhart2014pymtl,
	title={{PyMTL: A unified framework for vertically integrated computer architecture research}},
	author={Lockhart, Derek and Zibrat, Gary and Batten, Christopher},
	booktitle={IEEE/ACM Micro},
	pages={280--292},
	year={2014}
	} 
	
	#pipelined ASIC
	
	@article{basu2005fast,
	title={{Fast incremental updates for pipelined forwarding engines}},
	author={Basu, Anindya and Narlikar, Girija},
	journal={IEEE/ACM Transactions on Networking},
	volume={13},
	number={3},
	pages={690--703},
	year={2005}
	}
	
	@inproceedings{basu2003fast,
	title={{Fast incremental updates for pipelined forwarding engines}},
	author={Basu, Anindya and Narlikar, Girija},
	booktitle={IEEE INFOCOM},
	pages={64--74},
	year={2003}
	}
	
	@inproceedings{jiang2008beyond,
	title={{Beyond TCAMs: An SRAM-based parallel multi-pipeline architecture for terabit IP lookup}},
	author={Jiang, Weirong and Wang, Qingbo and Prasanna, Viktor K},
	booktitle={IEEE INFOCOM},
	pages={1786--1794},
	year={2008}
	}
	
	@article{jiang2012data,
	title={{Data structure optimization for power-efficient ip lookup architectures}},
	author={Jiang, Weirong and Prasanna, Viktor K},
	journal={IEEE Transactions on Computers},
	volume={62},
	number={11},
	pages={2169--2182},
	year={2012}
	}
	
	@inproceedings{kumar2006camp,
	title={{CAMP: fast and efficient IP lookup architecture}},
	author={Kumar, Sailesh and Becchi, Michela and Crowley, Patrick and Turner, Jonathan},
	booktitle={ACM/IEEE ANCS},
	pages={51--60},
	year={2006}
	}
	
	@inproceedings{hasan2005dynamic,
	title={{Dynamic pipelining: making IP-lookup truly scalable}},
	author={Hasan, Jahangir and Vijaykumar, TN},
	booktitle={ACM SIGCOMM},
	volume={35},
	number={4},
	pages={205--216},
	year={2005}
	}
	
	@article{han2010packetshader,
	title={{PacketShader: a GPU-accelerated software router}},
	author={Han, Sangjin and Jang, Keon and Park, KyoungSoo and Moon, Sue},
	journal={ACM SIGCOMM Computer Communication Review},
	volume={40},
	number={4},
	pages={195--206},
	year={2010}
	}
	
	@inproceedings{li2017meet,
	title={{MEET-IP: Memory and energy efficient TCAM-based IP lookup}},
	author={Li, Wenjun and Li, Xianfeng and Li, Hui},
	booktitle={IEEE ICCCN},
	pages={1--8},
	year={2017}
	}
	
	@inproceedings{zhao2010achieving,
	title={Achieving O (1) IP lookup on GPU-based software routers},
	author={Zhao, Jin and Zhang, Xinya and Wang, Xin and Xue, Xiangyang},
	booktitle={ACM SIGCOMM 2010},
	pages={429--430},
	year={2010}
	}
	
	@inproceedings{li2013gamt,
	title={{GAMT: a fast and scalable IP lookup engine for GPU-based software routers}},
	author={Li, Yanbiao and Zhang, Dafang and Liu, Alex X and Zheng, Jintao},
	booktitle={ACM/IEEE ANCS},
	pages={1--12},
	year={2013}
	}
	
	@inproceedings{sun2013fast,
	title={{Fast and flexible: Parallel packet processing with GPUs and click}},
	author={Sun, Weibin and Ricci, Robert},
	booktitle={ACM/IEEE ANCS},
	pages={25--35},
	year={2013}
	}
	
	@inproceedings{baboescu2005tree,
	title={{A tree based router search engine architecture with single port memories}},
	author={Baboescu, Florin and Tullsen, Dean M and Rosu, Grigore and Singh, Sumeet},
	booktitle={ACM/IEEE ISCA},
	pages={123--133},
	year={2005}
	}
	
	#GPU
	
	@article{han2011packetshader,
	title={PacketShader: a GPU-accelerated software router},
	author={Han, Sangjin and Jang, Keon and Park, KyoungSoo and Moon, Sue},
	journal={ACM SIGCOMM},
	volume={41},
	number={4},
	pages={195--206},
	year={2011}
	}
	
	@inproceedings{li2013gamt,
	title={{GAMT: a fast and scalable IP lookup engine for GPU-based software routers}},
	author={Li, Yanbiao and Zhang, Dafang and Liu, Alex X and Zheng, Jintao},
	booktitle={ACM/IEEE ANCS},
	pages={1--12},
	year={2013}
	} 
	
	@inproceedings{sun2013fast,
	title={Fast and flexible: parallel packet processing with GPUs and click},
	author={Sun, Weibin and Ricci, Robert},
	booktitle={ACM/IEEE ANCS},
	pages={25--36},
	year={2013}
	}
	
	
	#Direct lookup
	
	@inproceedings{gupta1998routing,
	title={Routing lookups in hardware at memory access speeds},
	author={Gupta, Pankaj and Lin, Steven and McKeown, Nick},
	booktitle={IEEE INFOCOM},
	volume={3},
	pages={1240--1247},
	year={1998}
	}
	
	#Bitmap
	
	@article{degermark1997small,
	title={Small forwarding tables for fast routing lookups},
	author={Degermark, Mikael and Brodnik, Andrej and Carlsson, Svante and Pink, Stephen},
	journal={ACM SIGCOMM},
	volume={27},
	number={4},
	year={1997}
	}
	
	@inproceedings{srinivasan1998faster,
	title={{Faster IP lookups using controlled prefix expansion}},
	author={Srinivasan, Venkatachary and Varghese, George},
	booktitle={ACM SIGMETRICS},
	volume={26},
	number={1},
	pages={1--10},
	year={1998}
	} 
	
	@inproceedings{srinivasan1998fast,
	title={Fast and scalable layer four switching},
	author={Srinivasan, Venkatachary and Varghese, George and Suri, Subhash and Waldvogel, Marcel},
	booktitle={ACM SIGCOMM},
	pages={191--202},
	year={1998}
	}
	
	@inproceedings{song2005shape,
	title={{Shape shifting tries for faster IP route lookup}},
	author={Song, Haoyu and Turner, Jonathan and Lockwood, John},
	booktitle={IEEE ICNP},
	pages={10--pp},
	year={2005}
	}
	
	@article{daly2019tuplemerge,
	title={Tuplemerge: Fast software packet processing for online packet classification},
	author={Daly, James and Bruschi, Valerio and Linguaglossa, Leonardo and Pontarelli, Salvatore and Rossi, Dario and Tollet, Jerome and Torng, Eric and Yourtchenko, Andrew},
	journal={IEEE/ACM transactions on networking},
	volume={27},
	number={4},
	pages={1417--1431},
	year={2019}
	}
	
	@incollection{liang2019neural,
	title={Neural packet classification},
	author={Liang, Eric and Zhu, Hang and Jin, Xin and Stoica, Ion},
	booktitle={ACM SIGCOMM},
	pages={256--269},
	year={2019}
	}
	
	@inproceedings{pfaff2015design,
	title={The design and implementation of open vswitch},
	author={Pfaff, Ben and Pettit, Justin and Koponen, Teemu and Jackson, Ethan and Zhou, Andy and Rajahalme, Jarno and Gross, Jesse and Wang, Alex and Stringer, Joe and Shelar, Pravin and others},
	booktitle={USENIX NSDI},
	pages={117--130},
	year={2015}
	}
	
	@inproceedings{jacobson1989space,
	title={{Space-efficient static trees and graphs}},
	author={Jacobson, Guy},
	booktitle={IEEE Annual Symposium on Foundations of Computer Science},
	pages={549--554},
	year={1989}
	}
	
	
	@article{eatherton2004tree,
	title={{Tree bitmap: hardware/software IP lookups with incremental updates}},
	author={Eatherton, Will and Varghese, George and Dittia, Zubin},
	journal={ACM SIGCOMM Computer Communication Review},
	volume={34},
	number={2},
	pages={97--122},
	year={2004},
	}
	
	@article{bando2012flashtrie,
	title={{FlashTrie: beyond 100-Gb/s IP route lookup using hash-based prefix-compressed trie}},
	author={Bando, Masanori and Lin, Yi-Li and Chao, H Jonathan},
	journal={IEEE/ACM Transactions On Networking},
	volume={20},
	number={4},
	pages={1262--1275},
	year={2012}
	}
	
	@inproceedings{bando2010flashtrie,
	title={{FlashTrie: Hash-based prefix-compressed trie for IP route lookup beyond 100Gbps}},
	author={Bando, Masanori and Chao, H Jonathan},
	booktitle={IEEE INFOCOM},
	pages={1--9},
	year={2010}
	}
	
	@article{lara2010industry,
	title={{Industry's Highest Bandwidth FPGA Enables World's First Single-FPGA Solution for 400G Communications Line Cards}},
	author={Lara, Greg},
	journal={Xilinx White Paper: Vertex-7 Family},
	year={2010}
	}
	
	@article{schreiber2002pico,
	title={{PICO-NPA: High-level synthesis of nonprogrammable hardware accelerators}},
	author={Schreiber, Robert and Aditya, Shail and Mahlke, Scott and Kathail, Vinod and Rau, B Ramakrishna and Cronquist, Darren and Sivaraman, Mukund},
	journal={Journal of VLSI signal processing systems for signal, image and video technology},
	volume={31},
	number={2},
	pages={127--142},
	year={2002},
	publisher={Springer}
	}
	
	@inproceedings{schreiber2000high,
	title={High-level synthesis of nonprogrammable hardware accelerators},
	author={Schreiber, Robert and Aditya, Shail and Rau, B Ramakrishna and Kathail, Vinod and Mahlke, Scott and Abraham, Santosh and Snider, Greg},
	booktitle={IEEE ASAP},
	pages={113--124},
	year={2000}
	}
	
	@inproceedings{kondratyev2013share,
	title={{Share with care: A quantitative evaluation of sharing approaches in high-level synthesis}},
	author={Kondratyev, Alex and Lavagno, Luciano and Meyer, Mike and Watanabe, Yosinori},
	booktitle={IEEE DATE},
	pages={1547--1552},
	year={2013}
	}
	
	@inproceedings{sanguinetti2012transaction,
	title={{Transaction-accurate interface scheduling in high-level synthesis}},
	author={Sanguinetti, John and Meredith, Michael and Dart, Sean},
	booktitle={IEEE Electronic System Level Synthesis Conference},
	pages={31--36},
	year={2012}
	}
	
	@inproceedings{song2015scalable,
	title={{Scalable name-based packet forwarding: From millions to billions}},
	author={Song, Tian and Yuan, Haowei and Crowley, Patrick and Zhang, Beichuan},
	booktitle={ACM ICN},
	pages={19--28},
	year={2015}
	}
	
	@article{zhang2014named,
	title={{Named data networking}},
	author={Zhang, Lixia and Afanasyev, Alexander and Burke, Jeffrey and Jacobson, Van and Claffy, KC and Crowley, Patrick and Papadopoulos, Christos and Wang, Lan and Zhang, Beichuan},
	journal={ACM SIGCOMM Computer Communication Review},
	volume={44},
	number={3},
	pages={66--73},
	year={2014},
	publisher={ACM New York, NY, USA}
	}
	
	@article{das2012smart,
	title={{Smart-Table Technology - Enabling Very Large Server, Storage Nodes and Virtual Machines to Scale Using Flexible Network Infrastructure Topologies}},
	author={Das, Sujal},
	journal={BROADCOM Corporation StrataXGS White Paper},
	year={2012}
	}
	
	@inproceedings{hoiland2018express,
	title={The express data path: Fast programmable packet processing in the operating system kernel},
	author={H{\o}iland-J{\o}rgensen, Toke and Brouer, Jesper Dangaard and Borkmann, Daniel and Fastabend, John and Herbert, Tom and Ahern, David and Miller, David},
	booktitle={ACM CoNEXT},
	pages={54--66},
	year={2018}
	}
	
	
	@inproceedings{yang2008compact,
	title={{Compact architecture for high-throughput regular expression matching on FPGA}},
	author={Yang, Yi-Hua E and Jiang, Weirong and Prasanna, Viktor K},
	booktitle={ACM/IEEE ANCS},
	pages={30--39},
	year={2008}
	}
	
	@inproceedings{qu2012large,
	title={Large-scale multi-flow regular expression matching on fpga},
	author={Qu, Yun and Yang, Yi-Hua E and Prasanna, Viktor K},
	booktitle={IEEE HPSR},
	pages={70--75},
	year={2012}
	}
	
	
	@inproceedings{ganegedara2012stridebv,
	title={{StrideBV: Single chip 400G+ packet classification}},
	author={Ganegedara, Thilan and Prasanna, Viktor K},
	booktitle={IEEE HPSR},
	pages={1--6},
	year={2012}
	}
	
	@inproceedings{tong2014high,
	title={High-throughput traffic classification on multi-core processors},
	author={Tong, Da and Qu, Yun R and Prasanna, Viktor K},
	booktitle={IEEE HPSR},
	pages={138--145},
	year={2014}
	} 
	
	@inproceedings{jiang2010architecture,
	title={Architecture-aware data structure optimization for green IP lookup},
	author={Jiang, Weirong and Prasanna, Viktor K},
	booktitle={IEEE HPSR},
	pages={113--118},
	year={2010}
	}
	
	@inproceedings{jiang2008parallel,
	title={Parallel IP lookup using multiple SRAM-based pipelines},
	author={Jiang, Weirong and Prasanna, Viktor K},
	booktitle={IEEE IPDPS},
	pages={1--14},
	year={2008}
	}
	
	@inproceedings{jamil2020multibit,
	title={{Multibit Tries Packet Classification with Deep Reinforcement Learning}},
	author={Jamil, Hasibul and Weng, Ning},
	booktitle={IEEE HPSR},
	pages={1--6},
	year={2020}
	}
	
	@inproceedings{jiang2013scalable,
	title={{Scalable ternary content addressable memory implementation using FPGAs}},
	author={Jiang, Weirong},
	booktitle={ACM/IEEE ANCS},
	pages={71--82},
	year={2013}
	}
	
	@article{brebner2014high,
	title={High-speed packet processing using reconfigurable computing},
	author={Brebner, Gordon and Jiang, Weirong},
	journal={IEEE Micro},
	volume={34},
	number={1},
	pages={8--18},
	year={2014}
	}